function class(base, init)
   local c = {}    -- a new class instance
   if not init and type(base) == 'function' then
      init = base
      base = nil
   elseif type(base) == 'table' then
      for i,v in pairs(base) do
         c[i] = v
      end
      c._base = base
   end
   c.__index = c
   local mt = {}
   mt.__call = function(class_tbl, ...)
   local obj = {}
   setmetatable(obj,c)
   if init then
      init(obj,...)
   else 
      if base and base.init then
      base.init(obj, ...)
      end
   end
   return obj
   end
   c.init = init
   c.is_a = function(self, klass)
      local m = getmetatable(self)
      while m do 
         if m == klass then return true end
         m = m._base
      end
      return false
   end
   setmetatable(c, mt)
   return c
end

obj_Achives = class()
function obj_Achives:init()
    self.HaveClone = 0                  -- параметр отвечающий за клонирование
    self.NeedSort = 1                   -- Флаг для разовой сортировки при открытии окна аччивок
    self.IgnWeb = {}                    -- для игнорирования ачивки по market "webok","webfb" , указываем номер "n" из  массива ниже
    self.CheckCol=0
    self.IgnWebSize = #self.IgnWeb
    self.Ach =  {
                    {   ar={1,30,3},    -- первое значение - значение, которого нужно достичь для получения ачивы
                        nm="Rookie",    -- внутриигровое имя ачивки
                        n=1,            -- порядковый номер ачивки
                        txt=7922,-- текстовый ID с текстом за получение ачивки
                        Pos=0, Val=0, ValTot=0, Ask=0, AskTot=0, RewVal=0, RewType=0, lvl=0, IdTmlp=-1, St=0 },     -- другие нужные параметры
                    {   ar={{1,3,2},{1,6,2},{1,12,2}},
                        nm="HonorStar",
                        n=2,
                        txt=7923,
                        Pos=0, Val=0, ValTot=0, Ask=0, AskTot=0, RewVal=0, RewType=0, lvl=0, IdTmlp=-1, St=0 },
                    {   ar={{1,100,1},{5,250,1},{12,625,1},{27,1500,1},{55,4000,1}},   
                        nm="FaithfulCompanion",               
                        n=3,
                        txt=7924,
                        Pos=0, Val=0, ValTot=0, Ask=0, AskTot=0, RewVal=0, RewType=0, lvl=0, IdTmlp=-1, St=0 },
                    {   ar={{1,1,5607},{5,1,5608},{12,75,5},{27,1,5609},{55,1,5610}},   
                        nm="BestRecruiter",               
                        n=4,
                        txt=7925,
                        Pos=0, Val=0, ValTot=0, Ask=0, AskTot=0, RewVal=0, RewType=0, lvl=0, IdTmlp=-1, St=0 },
                    {   ar={20,10,4},  
                        nm="InquisitiveCriminalist",                                                           
                        n=5,
                        txt=7926,
                        Pos=0, Val=0, ValTot=0, Ask=0, AskTot=0, RewVal=0, RewType=0, lvl=0, IdTmlp=-1, St=0 },
                    {   ar={{1,5,2},{2,9,2},{3,15,2}},                   
                        nm="BronzeMedal",                                   
                        n=6,
                        txt=7931,
                        Pos=0, Val=0, ValTot=0, Ask=0, AskTot=0, RewVal=0, RewType=0, lvl=0, IdTmlp=-1, St=0 },
                    {   ar={{3,12,2},{4,15,2},{5,18,2}},    
                        nm="SilverMedal",                                                
                        n=7,
                        txt=7932,
                        Pos=0, Val=0, ValTot=0, Ask=0, AskTot=0, RewVal=0, RewType=0, lvl=0, IdTmlp=-1, St=0 },
                    {   ar={{5,20,2},{6,25,2},{7,30,2}},   
                        nm="GoldMedal",                                                   
                        n=8,
                        txt=7933,
                        Pos=0, Val=0, ValTot=0, Ask=0, AskTot=0, RewVal=0, RewType=0, lvl=0, IdTmlp=-1, St=0 },
                    {   ar={{5,1,6597},{10,1,1077},{15,50,5},{25,1,5608},{45,1,5609}},  
                        nm="AnExperiencedInvestigator",     
                        n=9,
                        txt=7934,
                        Pos=0, Val=0, ValTot=0, Ask=0, AskTot=0, RewVal=0, RewType=0, lvl=0, IdTmlp=-1, St=0 },
                    {   ar={{5,1,6595},{10,1,1077},{15,50,5},{25,1,5608},{45,1,5609}},  
                        nm="VigilantPolice",                
                        n=10,
                        txt=7935,
                        Pos=0, Val=0, ValTot=0, Ask=0, AskTot=0, RewVal=0, RewType=0, lvl=0, IdTmlp=-1, St=0 },
                    {   ar={1,25,4},  
                        nm="VIPStatus",                                                                        
                        n=11,
                        txt=7936,
                        Pos=0, Val=0, ValTot=0, Ask=0, AskTot=0, RewVal=0, RewType=0, lvl=0, IdTmlp=-1, St=0 },
                    {   ar={{1,200,1},{3,500,1},{5,1000,1}},                   
                        nm="achiev14",                                
                        n=14,
                        txt=7939,
                       Pos=0, Val=0, ValTot=0, Ask=0, AskTot=0, RewVal=0, RewType=0, lvl=0, IdTmlp=-1, St=0 },
                    {   ar={{10,500,1},{30,1500,1},{50,2500,1}},                   
                        nm="achiev15",                            
                        n=15,
                        txt=7940,
                        Pos=0, Val=0, ValTot=0, Ask=0, AskTot=0, RewVal=0, RewType=0, lvl=0, IdTmlp=-1, St=0 },
                    {   ar={{1,100,1},{6,750,1},{14,2000,1}},                   
                        nm="achiev16",                               
                        n=16,
                        txt=7941,
                        Pos=0, Val=0, ValTot=0, Ask=0, AskTot=0, RewVal=0, RewType=0, lvl=0, IdTmlp=-1, St=0 },
                    {   ar={{1,30,3},{6,50,3},{14,80,3}},                   
                        nm="achiev17",                               
                        n=17,
                        txt=7942,
                        Pos=0, Val=0, ValTot=0, Ask=0, AskTot=0, RewVal=0, RewType=0, lvl=0, IdTmlp=-1, St=0 },
                    {   ar={{5000,5,2},{7000,10,2},{9000,15,2}},                   
                        nm="achiev18",                                    
                        n=18,
                        txt=7943,
                        Pos=0, Val=0, ValTot=0, Ask=0, AskTot=0, RewVal=0, RewType=0, lvl=0, IdTmlp=-1, St=0 },
                    {   ar={{15000,1,5608},{35000,1,5609},{100000,1,5610}},                   
                        nm="achiev19",                          
                        n=19,
                        txt=7944,
                        Pos=0, Val=0, ValTot=0, Ask=0, AskTot=0, RewVal=0, RewType=0, lvl=0, IdTmlp=-1, St=0 },
                    {   ar={{1,100,1},{5,1,2},{12,3,2},{27,7,2},{55,3,5608}},  
                        nm="achiev27",                                 
                        n=27,
                        txt=7952,
                        Pos=0, Val=0, ValTot=0, Ask=0, AskTot=0, RewVal=0, RewType=0, lvl=0, IdTmlp=-1, St=0 },
                    {   ar={{1,100,1},{5,1,2},{12,3,2},{27,7,2},{55,1,5608}},  
                        nm="achiev28",                                
                        n=28,
                        txt=7953,
                        Pos=0, Val=0, ValTot=0, Ask=0, AskTot=0, RewVal=0, RewType=0, lvl=0, IdTmlp=-1, St=0 },
                    {   ar={{1,100,1},{5,1,2},{12,3,2},{27,7,2},{55,1,5608}},  
                        nm="achiev29",                                
                        n=29,
                        txt=7954,
                        Pos=0, Val=0, ValTot=0, Ask=0, AskTot=0, RewVal=0, RewType=0, lvl=0, IdTmlp=-1, St=0 },
                }
    self.AchCntAll = #self.Ach -- кол-во аччивок
    if viewer.getOptParamI("set_data.fix.GCAchieve",0,0) ~= 2 then -- первый раз не даём награду за уже полученные
        obj_Achives:Load(1,self.AchCntAll)
        for i = 1, self.AchCntAll do
            if self.Ach[i]["St"] == 5 then 
                if type(self.Ach[i]["ar"][1]) == "table"  then  -- !! Многомерная
                    local ASumAsk = 0  --сумарный Ask до текущего уровня
                    local ACurLvl = 0 -- текущий лвл
                    for j = 1, #self.Ach[i]["ar"] do
                        ASumAsk = ASumAsk + self.Ach[i]["ar"][j][1]
                        if ASumAsk <= self.Ach[i]["ValTot"] then
                            ACurLvl = j
                        end
                    end
                    viewer.setOptParamI("gamecenter.ScptLvl."..self.Ach[i]["nm"],ACurLvl,0)
                    if self.Ach[i]["lvl"] == #self.Ach[i]["ar"] then
                        self.Ach[i]["St"] = 3
                    else
                        self.Ach[i]["St"] = 0
                    end
                else
                    viewer.setOptParamI("gamecenter.ScptLvl."..self.Ach[i]["nm"],1,0)
                    self.Ach[i]["St"]=3
                end 
            end
        end
        viewer.setOptParamI("set_data.fix.GCAchieve",2,0)
    end
end
function obj_Achives:Load(ABegin,AEnd)
    local CanObtain = 0 -- флаг, если можем получить
    for i = ABegin, AEnd do
        local AProgr = viewer.getOptParamF("gamecenter."..self.Ach[i]["nm"],0,0) 
        if type(self.Ach[i]["ar"][1])== "table" then  -- !! Многомерная
            self.Ach[i]["lvl"] = viewer.getOptParamI("gamecenter.ScptLvl."..self.Ach[i]["nm"],0,0) -- вычитываем полученный лвл
            if self.Ach[i]["lvl"] >= #self.Ach[i]["ar"] then  -- выполнили
                self.Ach[i]["Ask"] = self.Ach[i]["ar"][#self.Ach[i]["ar"]][1]
                self.Ach[i]["RewVal"] =  self.Ach[i]["ar"][#self.Ach[i]["ar"]][2]
                self.Ach[i]["RewType"] =  self.Ach[i]["ar"][#self.Ach[i]["ar"]][3] 
            else -- ещё нет
                self.Ach[i]["Ask"] = self.Ach[i]["ar"][self.Ach[i]["lvl"]+1][1]
                self.Ach[i]["RewVal"] =  self.Ach[i]["ar"][self.Ach[i]["lvl"]+1][2]
                self.Ach[i]["RewType"] =  self.Ach[i]["ar"][self.Ach[i]["lvl"]+1][3] 
            end
            local ASumAsk = 0  --сумарный Ask по всем уровням
            local ASumAskLvl = 0  -- сумарный Ask по всем уровням которые получили
            for j=1,#self.Ach[i]["ar"] do
                ASumAsk = ASumAsk + self.Ach[i]["ar"][j][1]
                if self.Ach[i]["lvl"] >= j then -- подсчитываем сколько нужно до тек. лвла
                    ASumAskLvl = ASumAskLvl + self.Ach[i]["ar"][j][1]
                end  
            end  
            self.Ach[i]["AskTot"] = ASumAsk
            self.Ach[i]["ValTot"] = math.floor((AProgr*ASumAsk)/100)
            if self.Ach[i]["lvl"] == #self.Ach[i]["ar"] then
                self.Ach[i]["Val"] = self.Ach[i]["Ask"]
            else
                self.Ach[i]["Val"] = self.Ach[i]["ValTot"] - ASumAskLvl
            end
            if self.Ach[i]["Val"] < 0 then -- подпорка для косяков несоответствия в лвлах
                self.Ach[i]["Val"] = 0
            end  
            if self.Ach[i]["Ask"] <= self.Ach[i]["Val"] then
                if self.Ach[i]["lvl"] ~= #self.Ach[i]["ar"] then  -- ещё не получили
                    self.Ach[i]["St"] = 5
                    CanObtain = 1
                else   -- получили
                    self.Ach[i]["St"] = 3
                end
            else
                self.Ach[i]["St"] = 0
            end 
        else -- !! Одномерная
            self.Ach[i]["Ask"] = self.Ach[i]["ar"][1] -- ещё не хватает условий
            self.Ach[i]["AskTot"] = self.Ach[i]["Ask"]
            if viewer.getOptParamI("gamecenter.ScptLvl."..self.Ach[i]["nm"],0,0) == 1 then  -- получена уже
                self.Ach[i]["St"] = 3
                self.Ach[i]["Val"] = self.Ach[i]["ar"][1]
                self.Ach[i]["lvl"] = 1
            elseif viewer.getOptParamI("gamecenter."..self.Ach[i]["nm"],0,0) == 100 then -- выполнена
                self.Ach[i]["St"] = 5   -- готова к получению
                CanObtain = 1
                self.Ach[i]["Val"] = self.Ach[i]["ar"][1]
            else -- ещё не выполнена
                if AProgr ~= 0 then
                    self.Ach[i]["Val"] = math.floor((AProgr * self.Ach[i]["Ask"]) / 100)
                else
                    self.Ach[i]["Val"] = 0
                end
            end
            self.Ach[i]["ValTot"] = self.Ach[i]["Val"]
            self.Ach[i]["RewVal"] =  self.Ach[i]["ar"][2]
            self.Ach[i]["RewType"] =  self.Ach[i]["ar"][3]
        end
    end
    if self.HaveClone == 0 and AEnd-ABegin > 1 then -- создание клонов 
        if viewer.getObjParamI(33627,"AchShow",0) == 1 then 
            self.AMarket = viewer.getOptParamS("market","sadok",0)
            for i = ABegin, AEnd do
                IgnWas = false
                if AMarketCheck == "web" then
                    for a = 1, self.IgnWebSize do         -- для проверки на ингор
                        if self.IgnWeb[a] == self.Ach[i]["n"] then
                            IgnWas=true
                        end  
                    end  
                end 
                if IgnWas == false then
                    viewer.changeObjState(33600,"clone")
                    self.Ach[i]["IdTmlp"] = viewer.getObjParamI(33627,"AchCloneId",-1)
                else
                end
            end 
            self.HaveClone = 1
        end
    end  
    if (AEnd - ABegin > 1) then -- открыто окно аччивок
        obj_Achives:Sort()
    end
    if CanObtain == 1 then -- аччивка готова к получению
        viewer.changeObjState(46097,"on")
    end 
end
function obj_Achives:CloneSet(AIdStart,ANum) -- заполняем темплейт
    local ARes = viewer.getResFromTxtDB(self.Ach[ANum]["txt"],1,0) -- вытягиваем графический ресурс
    viewer.setObjParamI(AIdStart+2,"res",ARes)    -- иконка
    if self.Ach[ANum]["ValTot"]==0 then  
        viewer.setObjParamF(AIdStart+2,"al",1) -- пустая аччивка
    else
        viewer.setObjParamI(AIdStart+2,"al",1) -- есть прогресс аччивка
    end
    local PercentLvl = 0  -- процент прогресса за один уровень
    if type(self.Ach[ANum]["ar"][1])== "table" then -- многомерная
        PercentLvl=100/#self.Ach[ANum]["ar"]
    else
        PercentLvl=100
    end 
    local ABufPercProgress = self.Ach[ANum]["Val"]/self.Ach[ANum]["Ask"]
    if ABufPercProgress>1 then
        ABufPercProgress = 1
    end
    local AProgr = math.floor(PercentLvl*(self.Ach[ANum]["lvl"]+self.Ach[ANum]["Val"]/self.Ach[ANum]["Ask"])) -- подсчёт прогресса
    if AProgr>100 then -- подпорка для последнего лвла
        AProgr=100
    end
    viewer.setObjParamI(AIdStart+6,"val",AProgr)   -- прогресс
    viewer.setObjParamI(AIdStart+27,"txtID",self.Ach[ANum]["txt"])  -- имя
    viewer.setObjParamI(AIdStart+28,"txtID",self.Ach[ANum]["txt"])  -- описание
    if self.Ach[ANum]["St"]==3 then   -- описание в зависимости от выполнености
        viewer.setObjParamI(AIdStart+28,"sense",1)
    else
        viewer.setObjParamI(AIdStart+28,"sense",2)
    end
    if self.Ach[ANum]["RewType"]==1 then  -- заполняем награду на кнопку
        viewer.setOptParamS("gamecenter.europe_cnt.obtain_rew",self.Ach[ANum]["RewVal"].." $id11501$dx-3",0)    --$id18620
    elseif self.Ach[ANum]["RewType"]==2 then
        viewer.setOptParamS("gamecenter.europe_cnt.obtain_rew",self.Ach[ANum]["RewVal"].." $id11504$dx-3",0)  --$id18618
    elseif self.Ach[ANum]["RewType"]==4 then
        viewer.setOptParamS("gamecenter.europe_cnt.obtain_rew",self.Ach[ANum]["RewVal"].." $id11503$dx-3",0)    
    else
        viewer.setOptParamS("gamecenter.europe_cnt.obtain_rew",viewer.getResFromTxtDB(self.Ach[ANum]["RewVal"],1,0),0) -- картинка
    end 
    if self.Ach[ANum]["St"]==5 then -- (можем получить) показываем кнопку и прячем прогресс лвл
        viewer.setObjParamI(AIdStart+13,"vis",0) -- прячем прогресс лвл
        viewer.setObjParamI(AIdStart+19,"vis",1) -- показываем кнопку
    else -- показываем прогресс
        viewer.setObjParamI(AIdStart+13,"vis",1)
        viewer.setObjParamI(AIdStart+19,"vis",0)
        if type(self.Ach[ANum]["ar"][1])== "table" then -- многомерная
            viewer.setObjParamI(AIdStart+15,"vis",1) -- 2
            viewer.setObjParamI(AIdStart+16,"vis",1) -- 3
            viewer.setObjParamI(AIdStart+17,"vis",1) -- 4
            if(#self.Ach[ANum]["ar"]==3) then
                viewer.setObjParamI(AIdStart+14,"vis",0)--1
                viewer.setObjParamI(AIdStart+18,"vis",0)--5
                if self.Ach[ANum]["lvl"]>0 then -- 2 звезда
                    viewer.setObjParamI(AIdStart+15,"res",16737)  
                else
                    viewer.setObjParamI(AIdStart+15,"res",16733)
                end 
                if self.Ach[ANum]["lvl"]>1 then -- 3 звезда
                    viewer.setObjParamI(AIdStart+16,"res",16737)
                else
                    viewer.setObjParamI(AIdStart+16,"res",16733)
                end 
                if self.Ach[ANum]["lvl"]>2 then -- 4 звезда
                    viewer.setObjParamI(AIdStart+17,"res",16737)
                else
                    viewer.setObjParamI(AIdStart+17,"res",16733)
                end
            else -- 5 уровней
                viewer.setObjParamI(AIdStart+14,"vis",1)--1
                viewer.setObjParamI(AIdStart+18,"vis",1)--5
                if self.Ach[ANum]["lvl"]>0 then -- 1 звезда
                    viewer.setObjParamI(AIdStart+14,"res",16737)  
                else
                    viewer.setObjParamI(AIdStart+14,"res",16733)
                end 
                if self.Ach[ANum]["lvl"]>1 then -- 2 звезда
                    viewer.setObjParamI(AIdStart+15,"res",16737)
                else
                    viewer.setObjParamI(AIdStart+15,"res",16733)
                end 
                if self.Ach[ANum]["lvl"]>2 then -- 3 звезда
                    viewer.setObjParamI(AIdStart+16,"res",16737)
                else
                    viewer.setObjParamI(AIdStart+16,"res",16733)
                end
                if self.Ach[ANum]["lvl"]>3 then -- 4 звезда
                    viewer.setObjParamI(AIdStart+17,"res",16737)
                else
                    viewer.setObjParamI(AIdStart+17,"res",16733)
                end
                if self.Ach[ANum]["lvl"]>4 then -- 5 звезда
                    viewer.setObjParamI(AIdStart+18,"res",16737)
                else
                    viewer.setObjParamI(AIdStart+18,"res",16733)
                end  
            end
        else -- одномерная
            viewer.setObjParamI(AIdStart+14,"vis",0)
            viewer.setObjParamI(AIdStart+15,"vis",0)
            viewer.setObjParamI(AIdStart+16,"vis",1)
            viewer.setObjParamI(AIdStart+17,"vis",0)
            viewer.setObjParamI(AIdStart+18,"vis",0)
            if self.Ach[ANum]["lvl"]>0 then -- выполнили
                viewer.setObjParamI(AIdStart+16,"res",16737)
            else
                viewer.setObjParamI(AIdStart+16,"res",16733)
            end
        end
    end
    viewer.setObjParamS(AIdStart+26,"txt",self.Ach[ANum]["ValTot"].." / "..(self.Ach[ANum]["Ask"] +self.Ach[ANum]["ValTot"]-self.Ach[ANum]["Val"]))
    if self.Ach[ANum]["ValTot"]==0 then  -- если пустая
        viewer.setObjParamF(AIdStart+26,"al",0.5)
    else            -- непустая
        viewer.setObjParamI(AIdStart+26,"al",1)
    end
    viewer.setObjParamI(AIdStart+12,"vis",1)  -- gr5 
    viewer.setObjParamI(AIdStart+25,"vis",1)  
    if type(self.Ach[ANum]["ar"][1])== "table" then -- многомерная
        for i=10,11 do --в любом случае последние две групы отображаем
            viewer.setObjParamI(AIdStart+i,"vis",1)  
            viewer.setObjParamI(AIdStart+13+i,"vis",1)
        end  
        local A_AddForSize =0 -- добавочное смещение для компенсации 3 и 5 уровней
        if #self.Ach[ANum]["ar"]==3 then -- проверяем количество уровней
            for i=8,9 do --рубим лишнее
                A_AddForSize = 2
                viewer.setObjParamI(AIdStart+i,"vis",0)  
                viewer.setObjParamI(AIdStart+13+i,"vis",0)
            end 
            viewer.setObjParamI(AIdStart+10,"x",220)
            viewer.setObjParamI(AIdStart+23,"x",190)
            viewer.setObjParamI(AIdStart+11,"x",372) 
            viewer.setObjParamI(AIdStart+24,"x",342)
        else -- 5-ти уровневая , или если тупнули в уровнях
            for i=8,9 do --вкл нехватаюшее
                viewer.setObjParamI(AIdStart+i,"vis",1)  
                viewer.setObjParamI(AIdStart+13+i,"vis",1)
            end 
            viewer.setObjParamI(AIdStart+10,"x",347)
            viewer.setObjParamI(AIdStart+23,"x",317)
            viewer.setObjParamI(AIdStart+11,"x",437) 
            viewer.setObjParamI(AIdStart+24,"x",407)
        end
        for j=1,#self.Ach[ANum]["ar"] do -- проходим по каунтерам     8-12 иконки    21-25 текст
            viewer.setObjParamI(AIdStart+A_AddForSize+j+20,"txt",self.Ach[ANum]["ar"][j][2])
            viewer.setObjParamF(AIdStart+A_AddForSize+j+7,"sx",0.60)
            viewer.setObjParamF(AIdStart+A_AddForSize+j+7,"sy",0.60)
            if self.Ach[ANum]["ar"][j][3]==1 then -- монеты
                viewer.setObjParamI(AIdStart+A_AddForSize+j+7,"res",21680)
            elseif   self.Ach[ANum]["ar"][j][3]==2 then -- кристаллы
                viewer.setObjParamI(AIdStart+A_AddForSize+j+7,"res",21679)
            elseif   self.Ach[ANum]["ar"][j][3]==3 then -- репутация
                viewer.setObjParamI(AIdStart+A_AddForSize+j+7,"res",21682)
            elseif   self.Ach[ANum]["ar"][j][3]==4 then -- звёзды
                viewer.setObjParamI(AIdStart+A_AddForSize+j+7,"res",21678)
            elseif   self.Ach[ANum]["ar"][j][3]==5 then -- єнергия
                viewer.setObjParamI(AIdStart+A_AddForSize+j+7,"res",21681)
            else -- предмет 
                viewer.setObjParamI(AIdStart+A_AddForSize+j+7,"res",viewer.getResFromTxtDB(self.Ach[ANum]["ar"][j][3],1,0)) 
            end
        end  
    else -- одномерная
        for i=8,11 do --рубим 4-е группы по vis
            viewer.setObjParamI(AIdStart+i,"vis",0)  
            viewer.setObjParamI(AIdStart+13+i,"vis",0)
        end  
        viewer.setObjParamI(AIdStart+25,"txt",self.Ach[ANum]["RewVal"]) -- каунтер gr5
        viewer.setObjParamF(AIdStart+12,"sx",0.60)
        viewer.setObjParamF(AIdStart+12,"sy",0.60)
        if self.Ach[ANum]["RewType"] == 1 then
            viewer.setObjParamI(AIdStart+12,"res",21680)
        elseif self.Ach[ANum]["RewType"] == 2 then
            viewer.setObjParamI(AIdStart+12,"res",21679)
        elseif   self.Ach[ANum]["RewType"] == 3 then -- репутация
            viewer.setObjParamI(AIdStart+12,"res",21682)   -- 18655
        elseif   self.Ach[ANum]["RewType"] == 4 then -- звёзды
            viewer.setObjParamI(AIdStart+12,"res",21678)
        elseif   self.Ach[ANum]["RewType"] == 5 then -- єнергия
            viewer.setObjParamI(AIdStart+12,"res",21681)
        else--предмет
            viewer.setObjParamI(viewer.getResFromTxtDB(self.Ach[ANum]["RewType"],1,0))
        end
    end
    viewer.changeObjState(AIdStart+1,"init") -- инитим внутриности клонов
    if self.Ach[ANum]["St"] == 5 then -- Share, можем получить, и текущий уровень на 1 меньше от максимального
        local MaxLvl = 1 -- по дефолту одномерная
        if type(self.Ach[ANum]["ar"][1])== "table" then--многомерная
            MaxLvl = #self.Ach[ANum]["ar"]
        end
        if self.Ach[ANum]["lvl"]==(MaxLvl-1) then
            viewer.changeObjState(AIdStart+29,"check") -- пинаем в проверку
        end
    end
end
function obj_Achives:UpdateTable(AData) -- заполняем таблицу
    for i=1,#AData do
        self.Ach[AData[i]]["Pos"] = self.PosNum   --указываем позицию
        obj_Achives:CloneSet(self.Ach[AData[i]]["IdTmlp"],AData[i])
        if self.NeedSort==1 then
            viewer.tableAddCellObj(31135,self.Ach[AData[i]]["IdTmlp"],0,self.PosNum-1)
        end
        self.PosNum = self.PosNum + 1
    end  
end
function obj_Achives:Sort()  -- При первом показе, после смены экрана, после получения награды
    if viewer.getObjParamI(33627,"AchShow",0) == 0 then -- запуск сортировки и отображение новой аччивки
        return 1;
    end
    self.PosNum=1 
    self.Ar_Done = {}
    self.Ar_CanObtain = {}  
    self.Ar_InProgress = {}
    self.Ar_None = {}
    self.AMarket = viewer.getOptParamS("market_check","sadok",0)
    local AMarketCheck = ""
    local IgnWas = false
    for i=1,self.AchCntAll do
        IgnWas = false
        if AMarketCheck=="web" then
            for a=1,self.IgnWebSize do         -- для проверки на ингор
                if self.IgnWeb[a] == self.Ach[i]["n"] then
                    IgnWas=true
                end  
            end  
        end 
        if IgnWas==false then -- проверяем игнор
            if self.Ach[i]["St"]==3 then -- выполненные
                self.Ar_Done[#self.Ar_Done+1]=i
            elseif self.Ach[i]["St"]==5 then
                self.Ar_CanObtain[#self.Ar_CanObtain+1]=i
            elseif self.Ach[i]["ValTot"]==0 then -- если пустые
                self.Ar_None[#self.Ar_None+1]=i
            else  -- Если не хватает
                self.Ar_InProgress[#self.Ar_InProgress+1]=i
            end
        end
    end 
    table.sort(self.Ar_InProgress,function(A,B) return (((self.Ach[A]["Val"]+0.01)/self.Ach[A]["Ask"]) > ((self.Ach[B]["Val"]+0.01)/self.Ach[B]["Ask"]))  end)  -- сортируем по убыванию отношения Val/Ask
    if self.NeedSort == 1 then -- если нужно перезаполнить таблицу
        viewer.tableClear(31135)
        obj_Achives:UpdateTable(self.Ar_CanObtain)
        obj_Achives:UpdateTable(self.Ar_InProgress)
        obj_Achives:UpdateTable(self.Ar_None)
        obj_Achives:UpdateTable(self.Ar_Done)
        self.NeedSort = 0
    end  
end
function obj_Achives:Obtain() -- логика при получении
    local clickRow = viewer.getObjParamI(31135,"clickRow",0) 
    local APos = clickRow + 1
    for i=1,self.AchCntAll do
        if self.Ach[i]["Pos"]==APos then
            local ALvl = viewer.getOptParamI("gamecenter.ScptLvl."..self.Ach[i]["nm"],0,0)
            viewer.setOptParamI("gamecenter.europe_cnt.RewType",self.Ach[i]["RewType"],0)
            viewer.setOptParamI("gamecenter.europe_cnt.RewVal",self.Ach[i]["RewVal"],0)
            self.Ach[i]["St"] = 3  -- помечаем как полученную
            local AIdLvl = 12 -- для смещения награды по группе   , дефолт награда в иконке 5 лвл   
            if type(self.Ach[i]["ar"][1]) == "table" then   -- многомерная
                AIdLvl = ALvl + 8 --ALvl(текущий полученный)
                if #self.Ach[i]["ar"] == 3 then -- трёхуровневая, смещаем на два id 
                    AIdLvl = AIdLvl+2
                end 
                if (ALvl+1)<=#self.Ach[i]["ar"] then -- последняя награда
                    viewer.setOptParamI("gamecenter.ScptLvl."..self.Ach[i]["nm"],ALvl+1,0)  --   ALvl++
                end  
            else -- одномерная
                viewer.setOptParamI("gamecenter.ScptLvl."..self.Ach[i]["nm"],1,0)      --   ALvl=1
            end  
            do -- для внешнего воздействия анимация + начисление
                local IdRes = 0
                if self.Ach[i]["RewType"]==1 then
                    IdRes=11501
                elseif self.Ach[i]["RewType"]==2 then
                    IdRes=11504
                elseif self.Ach[i]["RewType"]==3 then 
                    IdRes=11503
                elseif self.Ach[i]["RewType"]==4 then
                    IdRes=20194
                elseif self.Ach[i]["RewType"]==5 then
                    IdRes=11502
                else 
                    IdRes=viewer.getResFromTxtDB(self.Ach[i]["RewType"],1,0)
                end
                if self.Ach[i]["RewType"]>5 then -- предмет
                    viewer.setObjParamF(38261,"sx",0.60)
                    viewer.setObjParamF(38261,"sy",0.60)
                else
                    viewer.setObjParamI(38261,"sx",1)
                    viewer.setObjParamI(38261,"sy",1)
                end  
                viewer.setObjParamI(38261,"res",IdRes)
                viewer.setObjParamI(38257,"IdRew",self.Ach[i]["IdTmlp"]+AIdLvl)
                viewer.changeObjState(38261,"init")
                viewer.changeObjState(38257,"anim")
            end
            if ((viewer.getOptParamI("share",0,1))==0) then -- Share
                viewer.setObjParamS(31955,"achievement",self.Ach[i]["nm"])
                viewer.changeObjState(31955,"achievement_fb")
            end
            obj_Achives:Load(i,i)
            self.NeedSortObtain = 0 -- убрали обновление после получения награды по просьбе Оли Дядиной 14,09,17
            obj_Achives:CloneSet(self.Ach[i]["IdTmlp"],i)
            break
        end  
    end  
end
function obj_Achives:ObtainEnd() -- когда отработала анимация 
    if self.NeedSortObtain == 1 then
        self.NeedSort = 1
        obj_Achives:Sort()
        self.NeedSortObtain = 0
    end
end 
function obj_Achives:Find(guestID,AchId)
    for i=1,self.AchCntAll do
        if self.Ach[i]["txt"]==AchId then
            viewer.setObjParamI(guestID,"result",self.Ach[i]["Pos"]-1)
            break;
        end  
    end  
end  
function obj_Achives:CheckAchieveBox() --проверка аччивки на сундуки
    local A_Ar_Chest = {5810,5811,5812,5813,5814,5815,11302}
    local A_BoxID = viewer.getObjParamI(33627,"CheckAchieveBox",0)
    local A_Index = 0
    for i = 1, 7 do
        if (A_BoxID==A_Ar_Chest[i]) then
            if i==7 then
                A_Index=6
            else 
                A_Index=i
            end
            if viewer.getOptParamI("gamecenter.europe_cnt.box_0"..A_Index,0,1)==0 then
                viewer.setOptParamI("gamecenter.europe_cnt.box_01"..A_Index,1,1)
                obj_Achives:TrySend("eur_compass",1)
                break
            end
        end
    end
end
function obj_Achives:tap_cboxShare() ----меняем всем ачивкам параметр share на противоположный
    local share = viewer.getOptParamI("share",0,1)
    for i=1, #self.Ach do
        if (share == 0) then
            viewer.setObjParamI(self.Ach[i]["IdTmlp"]+33,"Share",1)
            viewer.setOptParamI("share", 1, 1)
            viewer.changeObjState(self.Ach[i]["IdTmlp"]+32,"invis")
        else
            viewer.setObjParamI(self.Ach[i]["IdTmlp"]+33,"Share",0)
            viewer.changeObjState(self.Ach[i]["IdTmlp"]+32,"vis")
            viewer.setOptParamI("share",0,1)
        end
    end
end
function obj_Achives:state(state,guestID)
	if (state == "Load") then
        obj_Achives:Load(1,self.AchCntAll)
    elseif (state == "CloneDie") then
        self.HaveClone=0
    elseif (state == "Obtain") then
        obj_Achives:Obtain()
    elseif (state == "ObtainEnd") then
        obj_Achives:ObtainEnd()
    elseif (state == "achievement_position") then
        obj_Achives:Find(guestID,viewer.getObjParamI(33627,"AchieveId",-1))
    elseif (state == "NeedSort") then
        self.NeedSort = 1
    elseif (state == "ClearTable") then
        viewer.tableClear(31135)
    elseif (state == "CheckAchieveBox") then -- Для аччивки на сундуки
        obj_Achives:CheckAchieveBox()
    elseif (state == "tap_cboxShare") then
        obj_Achives:tap_cboxShare()
    else  -- пытаемся запостить
        obj_Achives:TrySend(state,1)
	end
end
function obj_Achives:TrySend(state,value)
    for i=1,self.AchCntAll do
        if self.Ach[i]["nm"]==state then
            obj_Achives:Load(i,i)
            local LvlCanGet = 0
            if self.Ach[i]["St"]==5 then --аччивку можно получить
                LvlCanGet = obj_Achives:CheckLvlCanGet(i)
            end
            if (self.Ach[i]["ValTot"])~=self.Ach[i]["AskTot"] then -- ещё можно отсылать
                local AProgr = viewer.getOptParamI("gamecenter."..self.Ach[i]["nm"],0,0) 
                local AValNeed = 0
                local AValTryAd = value -- прибавка к шагу аччивки
                if state == "achiev19" then    -- аччивка требует накопить сумму монет на балансе 
                    local A_Val = viewer.getObjParamI(33627,"coins",0)
                    AValTryAd=A_Val-self.Ach[i]["ValTot"]
                elseif state == "achiev18" then    -- аччивка требует накопить сумму монет в гардеробной
                    local A_Val = viewer.getObjParamI(33627,"coins",0)
                    AValTryAd=A_Val-self.Ach[i]["ValTot"]
                elseif state == "InquisitiveCriminalist" then    -- аччивка требует ускорить экспертизу 10 раз или один раз на неделю
                    local A_Val = viewer.getObjParamI(33627,"expertise_count",0)
                    AValTryAd=A_Val
                end
                if AValTryAd > 0 then
                    AValNeed = math.ceil(((self.Ach[i]["ValTot"]+AValTryAd)*100)/self.Ach[i]["AskTot"])
                end 
                local ADelta = AValNeed - AProgr
                if ADelta > 0 then
                    viewer.setObjParamS(31955,"achievement",state)
                    viewer.setObjParamI(31955,"percent",ADelta)
                    viewer.changeObjState(31955,"achievement")
                    obj_Achives:Load(i,i)
                    if self.Ach[i]["St"]==5 then -- дёргаем окошко что аччивку можно получить
                        local CurLvlCanGet = obj_Achives:CheckLvlCanGet(i)
                        if LvlCanGet~= CurLvlCanGet then 
                            viewer.setObjParamI(37493,"txtID",self.Ach[i]["txt"])
                            viewer.setObjParamI(37493,"sense",4)
                            viewer.setObjParamI(37493,"x",-165)
                            viewer.setObjParamI(37493,"w",460)
                            viewer.changeObjState(37493,"init")
                            viewer.changeObjState(37495,"init")
                            viewer.changeObjState(37482,"open")
                            if CurLvlCanGet==#self.Ach[i]["ar"] then -- последний уровень
                                viewer.setOptParamI("public.Achiew",viewer.getOptParamI("public.Achiew",0,1)+1,1)
                            end
                        end  
                    end  
                end
            end  
            return
        end  
    end 
end
function obj_Achives:CheckLvlCanGet(i) -- возвращаем уровень который может получить игрок
    local SumAsk = 0  --сумарный Ask на текущий момент
    local j = 1 -- итератор
    if type(self.Ach[i]["ar"][1])== "table"  then
        for j=1,#self.Ach[i]["ar"] do
            SumAsk = SumAsk + self.Ach[i]["ar"][j][1]
            if SumAsk>self.Ach[i]["ValTot"] then -- Если аск больше текущего значения - заканчиваем
                break
            end
        end
    end
    return j
end

obj_ani_stars_mysteries = class()
function obj_ani_stars_mysteries:state(state,guestID)
    if 	(state == "first_step") then
		first_step()
	end
  	function first_step()
    	--считаем предыдущее значение прогресса
        local location = viewer.getObjParamI(21,"param",0)
        local prev_progress = viewer.getOptParamI("ecomics21.loc"..location..".prev_prog",0,1)
        local cur_progress = viewer.getObjParamI(29611,"new_val",100)
        local isNewLevel = viewer.getOptParamI("ecomics21.loc"..location..".is_new",0,1)
        local new_res3_num = math.floor(cur_progress/100)
        local pc = viewer.getOptParamI("ecomics21.loc"..location..".pc",0,1)
        local sc = viewer.getOptParamI("ecomics21.loc"..location..".sc",0,1) 
        viewer.setObjParamI(29613,"new_res3_num",new_res3_num)
        viewer.setObjParamI(33627,"delta_value",cur_progress-prev_progress)
        if(new_res3_num > 0) then
            viewer.setOptParamI("ecomics21.loc"..location..".is_new",0,1)
        end  
        viewer.setObjParamI(29612,"new_val",prev_progress)
        viewer.changeObjState(29612,"init")
        if ((new_res3_num % 5) == 0 and isNewLevel == 0 and (pc ~= 0 or sc ~= 0)) then
            viewer.setOptParamI("ecomics21.loc"..location..".prev_prog",0,1)
        else  
            viewer.setOptParamI("ecomics21.loc"..location..".prev_prog",cur_progress,1)
        end
  	end
end

obj_check_2nd_place = class() 
function obj_check_2nd_place:state(state,guestID)
    if 	(state == "check") then
        check()
    end
  	function check()
        local place = viewer.getOptParamI("temporary_me_place_pre",0,0)
        local level = viewer.getOptParamI("ecomics21.level",0,1)
        local itemID = 0
        if (place == 2) then
            if (level < 11) then
                itemID = 5629
            elseif (level >= 11 and level < 28) then
                itemID = 5630
            elseif (level >=28 and level < 101) then
                itemID = 5631
            end
            viewer.setObjParamI(22,"param",itemID)
            viewer.changeObjState(22,"use_param")
        end
    end
    if 	(state == "check_old") then
        check_old()
    end
    function check_old()
        for i = 5629,5631  do
            if (viewer.getOptParamI("eitems22.i"..i,0,1) > 0) then
                viewer.setObjParamI(22,"param",i)
                viewer.changeObjState(22,"use_param")
            end
        end
    end
end

obj_conveyorSettings = class() 
conveyorSettings = {
    {
        {21846,13418,-1,-1,-1,-1,-1},
        {
            {13419,21610},
            {13376,21597},
            {13383,21615},
            {13379,21622},
            {13415,21612}
         },
        {-1,-1,-1,13418,-1,-1,-1}
    }, 
    {
        {},
        {},
        {}
    }, 
    {
        {13416,13416,13378,-1,-1,-1,-1,-1,-1,-1},
        {
            {21844,21854},
            {13980,21596},
            {13385,21611},
            {21844,21854},
            {13980,21596},
            {21846,21859},
            {21845,21861}
         },
        {-1,-1,-1,13378,13416,-1,-1,-1,-1,-1}
    }, 
    {
        {},
        {},
        {}
    }, 
    {
        {},
        {},
        {}
    }, 
    {
        {21848,13382,21851,13377,-1,-1,-1,-1,-1,-1,-1,-1},
        {
            {15573,21603},
            {13385,21611},
            {15576,21601},
            {15574,21614},
            {15573,21603},
            {15574,21614},
            {21556,21616},
            {15575,21599}
         },
        {-1,-1,-1,-1,15573,-1,-1,-1,-1,-1,-1,-1}
    }, 
    {
        {},
        {},
        {}
    }, 
    {
        {13981,13380,16765,16745,21845,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1},
        {
            {21847,21860},
            {21849,21856},
            {13386,21618},
            {13414,21605},
            {21852,21853},
            {13381,21604},
            {13984,21595},
            {13378,21602},
            {13383,21615},
            {21850,21857}
         },
        {-1,-1,-1,-1,16765,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1}
    }, 
    {
        {21847,21846,13383,13379,15574,-1,-1,-1,-1,-1,-1,-1},
        {
            {15577,21600},
            {13384,21624},
            {13386,21618},
            {13419,21610},
            {13376,21597},
            {13415,21612},
            {21845,21861}
         },
        {-1,-1,-1,-1,15574,-1,-1,-1,-1,-1,-1,-1}
    }, 
    {
        {},
        {},
        {}
    }, 
    {
        {21192,21847,13384,13376,13980,-1,-1,-1,-1,-1,-1,-1,-1,-1},
        {
            {15575,21599},
            {13981,21594},
            {13386,21618},
            {13419,21610},
            {13383,21615},
            {21850,21857},
            {21846,21859},
            {21844,21854},
            {21848,21855}
         },
        {-1,-1,-1,-1,-1,-1,-1,21192,-1,-1,-1,-1,-1,-1}
    }, 
    {
        {},
        {},
        {}
    }, 
    {
        {},
        {},
        {}
    }, 
    {
        {},
        {},
        {}
    }, 
    {
        {21556,13983,13984,13418,15573,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1},
        {
            {13417,21609},
            {13379,21622},
            {16745,21613},
            {13381,21604},
            {21852,21853},
            {13414,21605},
            {16745,21613},
            {16765,21598},
            {13382,21606},
            {21851,21858}
         },
        {-1,-1,-1,-1,-1,-1,21556,-1,-1,-1,-1,-1,-1,-1,-1},
        {13418,13982,15576,13417,13415,13416,13386,-1,-1,-1,-1,-1,-1,-1},
        {
            {21849,21856},
            {13380,21617},
            {15577,21600},
            {13983,21620},
            {13380,21617},
            {13980,21596},
            {21844,21854}
         },
        {-1,13418,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1}
    }, 
    {
        {21556,21192,13383,15574,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,},
        {
            {13385,21611},
            {21848,21855},
            {15576,21601},
            {13382,21606},
            {21851,21858},
            {21850,21857},
            {15573,21603},
            {13415,21612},
            {13377,21619},
            {13379,21622},
            {15575,21599}
         },
        {-1,-1,-1,-1,-1,-1,-1,15573,-1,-1,-1,-1,-1,-1,-1,-1,-1}
    },
    {
        {},
        {},
        {}
    }, 
    {
        {},
        {},
        {}
    }, 
    {
        {},
        {},
        {}
    }, 
    {
        {},
        {},
        {}
    }, 
    {
        {13380,13419,22584,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1},
        {
            {13376,21597}, --кисть для пудры
            {21846,21859}, --фонарик
            {21849,21856}, --кекс
            {13386,21618}, --пудра
            {21849,21856}, --кекс
            {13377,21619}, --кошелек
            {21847,21860}, --белая чашка
            {13379,21622}, --телефон
            {15577,21600}, --цветок
            {21850,21857}, --карандаш
            {15577,21600}, --цветок
            {13384,21624}, --расческа
         },
        {-1,-1,-1,22584,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1}
    }, 
    {
        {},
        {},
        {}
    }, 
    {
        {22707,13419,22584,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1},
        {
            {13981,21594}, --синяя чашка
            {13378,21602}, --красный стакан
            {21845,21861}, --синий стакан в горошек
            {13416,21607}, --винная бутылка
            {21844,21854}, --бутылка кетчупа
            {13418,21621}, --окурок
            {16765,21598}, --штопор с пробкой
            {13414,21605}, --швейцарский нож
            {13983,21620}, --пакет сока
            {13984,21595}, --чайный пакетик
            {13417,21609}, --зажигалка
         },
        {-1,-1,-1,22707,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1}
    }, 
    {
        {},
        {},
        {}
    }, 
    {
        {22758,13984,15573,15575,15574,-1,-1,-1,-1,-1,-1,-1,-1,-1},
        {
            {13982,21608}, --пульверизатор
            {13984,21595}, --чайный пакетик
            {15573,21603}, --шприц
            {15575,21599}, --марлевая повязка
            {21556,21616}, --никотиновый пластырь
            {15574,21614}, --медицинский пластырь
            {15576,21601}, --резиновый жгут
            {13385,21611}, --баночка таблеток
            {13378,21602}, --красный стакан
         },
        {-1,-1,-1,-1,22758,-1,-1,-1,-1,-1,-1,-1,-1,-1}
    }, 
    {
        {},
        {},
        {}
    }, 
}                                           

obj_DONT_DELETE_event_text = class()
function obj_DONT_DELETE_event_text:getString()
    local questTxtID = -- здесь хранится текстовый айдишник с текстом задания
        {   10840,  -- 1 ивент
            10841,  -- 2 ивент
            11043,  -- 3 ивент
            11220,  -- 4 ивент
            11206,  -- 5 ивент
            -1,  -- 6 ивент
            -1,  -- 7 ивент
            -1,  -- 8 ивент
            -1,  -- 9 ивент
            -1,  -- 10 ивент
            -1,  -- 11 ивент
            -1,  -- 12 ивент
            -1,  -- 13 ивент
            -1,  -- 14 ивент
            -1,  -- 15 ивент
            -1,  -- 16 ивент
        }
    local event = tonumber(viewer.getObjState(56530))
    print("event = "..event)
    local quest = viewer.getStrFromTxtDB(questTxtID[event],0,"")
    viewer.setObjParamS(56530,"text_quest",quest)   -- то, что записано в этом параметре - будет использоваться в игре потом
end
function obj_DONT_DELETE_event_text:state(state,guestID)
    if 	(state == "getString") then
		obj_DONT_DELETE_event_text:getString()
    end
end

obj_event_is_day_right = class()
function obj_event_is_day_right:init()
    weeks ={    -- здесь хранятся даты ивентов
                {1,  7,  0 },               -- 1 ивент
                {29, 35, 0 }, -- +{1, 4, 7 }-- 2 ивент
                {12, 18, 1 },               -- 3 ивент
            }
    casesEvent ={    -- здесь хранятся айдишники тасок
                {10660,10661,10662,10691,10692,10693,10694,10695,10696,10697,10698,10699,10700,10701,10702,10703,10704,10705,10706}, -- 1 ивент
                {10688,10689,10690,10843,10844,10845,10846,10847,10848,10849,10850,10851,10852,10853,10854,10855,10856,10857,10858}, -- 2 ивент
                {10943,10944,10945,10946,10947,10948,10949,10950,10951,10952,10953,10954,10955,10956,10957,10958,10959,10960,10961,10962,10963},     -- 3 ивент
                {11168,11169,11170,11171,11172,11173,11174,11175,11176,11177,11178,11179,11180,11181,11182,11183,11184,11185,11186,11187,11188,11189,11190,11191,11192,11193},     -- 4 ивент
                {11059,11060,11061,11062,11063,11064,11065,11066,11067,11068,11069,11070,11071,11072,11073,11074,11075,11076,11077,11078,11079,11080,11081},     -- 5 ивент
                {},     -- 6 ивент
                {},     -- 7 ивент
                {},     -- 8 ивент
                {},     -- 9 ивент
                {},     -- 10 ивент
                {},     -- 11 ивент
                {},     -- 12 ивент
                {},     -- 13 ивент
                {},     -- 14 ивент
                {},     -- 15 ивент
                {},     -- 16 ивент
            }
    mainLoc ={    -- здесь хранятся номер главной локации для каждого ивента
                14,    -- 1 ивент
                18,    -- 2 ивент
                15,    -- 3 ивент
                16,    -- 4 ивент
                21,    -- 5 ивент
                1 ,    -- 6 ивент
                1 ,    -- 7 ивент
                1 ,    -- 8 ивент
                1 ,    -- 9 ивент
                1 ,    -- 10 ивент
                1 ,    -- 11 ивент
                1 ,    -- 12 ивент
                1 ,    -- 13 ивент
                1 ,    -- 14 ивент
                1 ,    -- 15 ивент
                1 ,    -- 16 ивент
            }
end
function obj_event_is_day_right:state(state,guestID)
	if 	(state == "check") then
		obj_event_is_day_right:check()
	end
end
function obj_event_is_day_right:notification()
    local day   = viewer.getOptParamI("cur_day",0,0)
    local month = viewer.getOptParamI("cur_mon",0,0)
    local weekd = viewer.getOptParamI("cur_weekd",0,0)
    local shiftToSaturday = 6 - weekd           -- сдвиг от сегодняшнего дня до субботы гарантировано придвинет нотификейшен 
    local daysToNotification = 0                -- к субботе, когда мы найдем первое вхождение в ивентовую неделю 
    notifcheck = false -- просто флаг, который сообщает нам, что все готово и можно покинуть цикл
    while (notifcheck == false) do
        for i = 1, #weeks do
            if ( (day + shiftToSaturday >= weeks[i][1])  and (day  + shiftToSaturday <= weeks[i][2]) and (month == weeks[i][3]) ) then
                daysToNotification = daysToNotification + shiftToSaturday
                if daysToNotification > 0 then
                    viewer.setObjParamI(46734,"delay",daysToNotification * 86400) --отправляем машине колво дней в секундах
                    day = math.fmod(day  + shiftToSaturday, 31)
                    month = month + 1
                    print("Ивентовая суббота наступит "..day.." числа "..month.." месяца")
                    print("Уведомление будет показано через "..daysToNotification.." дней")
                    viewer.changeObjState(46734,"event")
                end
                notifcheck = true
                break
            end
        end
        if (notifcheck == true) then 
            break 
        end
        day = day + 7
        daysToNotification = daysToNotification + 7
        if ( (month == 0) or (month == 2) or (month == 4) or (month == 6) or (month == 7) or (month == 9) or (month == 11) ) then
            if day > 31 then
                day = math.fmod(day, 31)
                month = math.fmod(month + 1, 12) -- перенесет нас с декабря на январь, если что
            end
        elseif ( (month == 3) or (month == 5) or (month == 8) or (month == 10) ) then
            if day > 30 then
                day = math.fmod(day, 30)
                month = month + 1
            end
        else
            if day > 28 then
                day = math.fmod(day, 28)
                month = month + 1
            end
        end
    end
end
function obj_event_is_day_right:check()
    local day   = viewer.getOptParamI("cur_day",0,0)
    local month = viewer.getOptParamI("cur_mon",0,0)
    local weekd = viewer.getOptParamI("cur_weekd",0,0)
    print("today is day #"..day..", month #"..month..", day of week #"..weekd)
    local is_updated = viewer.getOptParamI("event.app_updated",0,1)
    if (is_updated == 1) then
        local update_event = 4 
        print("ивент "..update_event.." активирован для апдейта")
        viewer.setOptParamI("event.app_updated",0,1)
        obj_event_is_day_right:reset(update_event)
        return 0
    end
    for i = 1,#weeks do
        if ( 
                (  
                    (day >= weeks[i][1]) and (day <= weeks[i][2]) and (month == weeks[i][3]) and (weekd == 6)
                 ) or (
                    (day >= weeks[i][1] + 1)  and (day <= weeks[i][2]  + 1) and (month == weeks[i][3]) and (weekd == 0)
                 ) or (
                    (day >= weeks[i][1] + 2)  and (day <= weeks[i][2]  + 2) and (month == weeks[i][3]) and (weekd == 1)
                 )
            ) then
            if (viewer.getOptParamI("num_case_event",0,1) ~= i) then
                obj_event_is_day_right:reset(i)
            else
                print("ивент "..i.." был активирован во время апдейта")
            end
            break
        else 
            print("ивент "..i.." не активирован")
        end   
        if (weeks[i][2] > 31) then
            if ( 
                    (
                        (day >= 1)  and (day <= weeks[i][2] - 31) and (month == weeks[i][3] + 1) and (weekd == 6)
                     ) or (
                        (day >= 1)  and (day <= weeks[i][2] - 30) and (month == weeks[i][3] + 1) and (weekd == 0)
                     ) or (
                        (day >= 1)  and (day <= weeks[i][2] - 29) and (month == weeks[i][3] + 1) and (weekd == 1)
                     )
                ) then
                if (viewer.getOptParamI("num_case_event",0,1) ~= i) then
                    obj_event_is_day_right:reset(i)
                else
                    print("ивент "..i.." был активирован во время апдейта")
                end
                break
            else 
                print("ивент "..i.." не активирован")
            end 
        end
    end
    if (viewer.getOptParamI("event.is_day_right",0,1) == 0) then
        obj_event_is_day_right:notification()
    end
end
function obj_event_is_day_right:reset(i)
    local tasks = casesEvent[i]
    for j = 1, #tasks do
        local task = tasks[j]
        viewer.setObjParamI(145,"param",task)
        viewer.changeObjState(145,"reactivate")
    end
    viewer.setOptParamI("finish_case.win_deal_event"..i,0,1)
    viewer.setOptParamI("event.logbook.photo1_case",22537,1)
    viewer.setOptParamI("event.logbook.photo2_case",22537,1)
    viewer.setOptParamI("event.logbook.txt1_case",7135,1)
    viewer.setOptParamI("event.logbook.txt2_case",7135,1)
    viewer.setOptParamI("event.time_added",0,1)             -- сброс количества продлений времени
    viewer.setOptParamI("ads.30_minutes",0,1)               -- сброс количества просмотров рекламы
    viewer.setOptParamI("event.mainLoc",mainLoc[i],1)       -- установка главной локации (она будет открыта на время ивента)
    viewer.setOptParamI("event.is_day_right",1,1)           -- даем сигнал сейлсменеджеру
    print("ивент "..i.." активирован")
    viewer.setOptParamI("num_case_event",i,1)               -- сюда записываем номер кейса
    if viewer.getOptParamI("eitems22.i10773",0,1) < 1 then
        viewer.setObjParamI(22,"param",10773)
        viewer.setObjParamI(22,"param_num",1)
        viewer.changeObjState(22,"add_param")
    end
    viewer.changeObjState(44333,"check_multiple")
    print("Ивент сделал БУМ!")
end

obj_firebase_res_item = class()
function obj_firebase_res_item:state(state,guestID)
	if 	(state == "check") then
        viewer.setObjParamS(56223,"itemRes",viewer.getResFromTxtDB(viewer.getObjParamI(56223,"fcm_item",0),1,0))
	end
end

obj_firetrucks_manager = class()
function obj_firetrucks_manager:state(state,guestID)
	if (state == "houseClick") then
        for house = 1,#houses do
            if guestID == houses[house] then
                print("House "..house.." clicked")
                obj_firetrucks_manager:onClickHouse(house)
                break
            end
        end
	end
    if (state == "firecarClick") then
        print("Car "..questID.." clicked")
        obj_firetrucks_manager:onClickFirecar(guestID)
    end
    if (state == "startAnimation") then
        for house = 1,#houses do
            if guestID == houses[house] then
                print("Firecar arrived to house "..house)
                if car1 == house then
                    obj_firetrucks_manager:startAnimation(house,53305)
                else
                    obj_firetrucks_manager:startAnimation(house,55501)
                break
                end
            end
        end
	end
    if (state == "endAnimation") then
        for house = 1,#houses do
            if guestID == houses[house] then
                print("Firecar finished with house "..house)
                if car1 == house then
                    obj_firetrucks_manager:endAnimation(house,1)
                else
                    obj_firetrucks_manager:endAnimation(house,2)
                break
                end
            end
        end
	end
    if (state == "nextFire") then
        obj_firetrucks_manager:nextFire(guestID)
	end
    if (state == "accelerate") then
        obj_firetrucks_manager:accelerate()
    end   
end
function obj_firetrucks_manager:onClickHouse(house)
    local isostate = viewer.getObjState(houses[house])
    local windowState = "init"  -- эта переменная принимает состояние окна для последующего открытия
    if car1 == house then
        print("Car 1 already got house "..car1)
        if isostate == "acting_wait" then
            windowState = "open_car_goes"
        else
            windowState = "open_car_busy"
            viewer.setObjParamI(53311,"carID",52889)    -- передаем айдишник машины окну - он нужен для функции accelerate()
        end                                          
    elseif car1 == 0 then
        obj_firetrucks_manager:startWork(house,1)
        windowState = "open_car_goes"
    elseif car1 ~= 0 and car1 ~= house then
        print("Car 1 is busy on house "..car1..", checking for the car 2...")
        local secondCar = viewer.getOptParamI("fires.firecar.bought",0,1)
        if secondCar == 1 then
            if car2 == house then
                print("Car 2 already got house "..car2)
                if isostate == "acting_wait" then
                    windowState = "open_car_goes"
                else
                    windowState = "open_car_busy"
                    viewer.setObjParamI(53311,"carID",55496)    -- передаем айдишник машины окну - он нужен для функции accelerate()
                end
            elseif car2 == 0 then
                obj_firetrucks_manager:startWork(house,2)
                windowState = "open_car_goes"
            elseif car2 ~= 0 and car2 ~= house then
                print("Car 2 is busy on house "..car2)
                obj_firetrucks_manager:addToQueue(house)    -- добавляем дом в очередь
                windowState = "open_no_cars"
            end
        else
            print("Car 2 is unavaliable :(")
            obj_firetrucks_manager:addToQueue(house)    -- добавляем дом в очередь
            windowState = "open_no_cars"
        end
    end
    viewer.changeObjState(53311,windowState)
end
function obj_firetrucks_manager:onClickFirecar(carID)
    local isostate = viewer.getObjState(carID)  -- считываем состояние изомувера
    local windowState = "init"      -- сюда запишем состояние, которое передадим окну по клику на машину
    if isostate == "moving_spline" then     -- если машина в движении
        windowState = "open_car_goes"
    else                                    -- если машина не в движении, значит она уже тушит дом
        windowState = "open_car_busy"
        viewer.setObjParamI(53311,"carID",carID)    -- передаем айдишник машины, нужен для функции accelerate()
    end
    viewer.changeObjState(53311,windowState)
end
function obj_firetrucks_manager:accelerate()
    local carID = viewer.getObjParamI(53311,"carID",52889)  -- если мы передаем окну пожарки состояние "open_car_busy", то надо передать
    if carID == 52889 then                                  -- также и айдишник машины, которая его тушит, иначе ускорение сработает некорректно
        print("Car 1 accelerated")
        obj_firetrucks_manager:endAnimation(car1,1)     -- в car1 у нас хранится номер дома, так что мы можем просто вызвать конец тушения
    else
        print("Car 2 accelerated")
        obj_firetrucks_manager:endAnimation(car2,2)     -- аналогично car1
    end
end
function obj_firetrucks_manager:nextFire(carID)
    if carID == 52889 then    -- для первой пожарной машины
        if #queue == 0 then     -- сюда заходим, если в очереди нет домов, этот if отправит машинку домой
            car1 = 0 
            viewer.setObjParamI(52889,"finish",137)            -- 137 это финишная нода
            viewer.changeObjState(52889,"move_to_smooth") 
            print("Car 1 goes to finish")
        else
            house = queue[1]        -- а иначе вытаскиваем первый в очереди дом и ставим его пожарным
            table.remove(queue,1)   -- сам дом из очереди после этого удаляется, естественно
            local queueNow = "{"
            for i = 1,#queue do
                queueNow = queueNow..queue[i]..","  -- это для вывода в лог
            end
            queueNow = queueNow.."}"
            print("House "..house.." removed from queue! Queue: "..queueNow)
            obj_firetrucks_manager:startWork(house,1)
        end
    else        -- тут все то же самое, только для второй машины
        if #queue == 0 then
            car2 = 0
            viewer.setObjParamI(55496,"finish",137)        -- 137 это финишная нода
            viewer.changeObjState(55496,"move_to_smooth") 
            print("Car 2 goes to finish")
        else
            house = queue[1]
            table.remove(queue,1)
            local queueNow = "{"
            for i = 1,#queue do
                queueNow = queueNow..queue[i]..","
            end
            queueNow = queueNow.."}"
            print("House "..house.." removed from queue! Queue: "..queueNow)
            obj_firetrucks_manager:startWork(house,2)
        end
    end
end
function obj_firetrucks_manager:addToQueue(house)
    local flag = false      -- флаг, который говорит, можно ли добавить дом в очередь
    for i = 1,#queue do     -- false - можно, true - нельзя
        if queue[i] == house then
            flag = true
            print("house "..house.." is already in queue")
            break
        end
    end
    if flag == false then
        table.insert(queue,house)
        local queueNow = "{"
        for i = 1,#queue do
            queueNow = queueNow..queue[i]..",";
        end
        queueNow = queueNow.."}"
        print("House "..house.." added to queue! Queue: "..queueNow)
    end
end
function obj_firetrucks_manager:startWork(house,car_num)
    if car_num == 1 then
        car1 = house
        obj_firetrucks_manager:chooseAnimation(house,53305)
        viewer.setObjParamI(52889,"finish",nodes[house])
        print("Car 1 goes to "..house)
        viewer.changeObjState(52889,"move_to_smooth")
    else 
        car2 = house
        obj_firetrucks_manager:chooseAnimation(house,55501)
        viewer.setObjParamI(55496,"finish",nodes[house])
        print("Car 2 goes to "..house)
        viewer.changeObjState(55496,"move_to_smooth")
    end
    local house_name = "house"..house
    viewer.setObjParamI(houses[house],"pow",50)
    local houseRep = viewer.getObjParamI(52900,"houses",0)
    viewer.setObjParamI(52900,"houses",houseRep-1)
end
function obj_firetrucks_manager:chooseAnimation(house,animationID)
    local animSX = {1,4,6,9,10,12,14,15,17,19}
    local animstate = "init"
    for i = 1,#animSX do
        if animSX[i] == house then
            animstate = "sx"    -- для определенных домов нам надо развернуть анимацию по оси Х
            break
        end
    end
    if house == 7 then
        viewer.setObjParamI(animationID,"angle",-90) -- довольно специфично, не так ли
    end
    viewer.changeObjState(animationID,animstate)
end
function obj_firetrucks_manager:startAnimation(house,animationID)
    local animUncommon = {2,3,4,7,8,9,10,12,13,16,18,20}
    local animstate = "common"
    for i = 1,#animUncommon do
        if animUncommon[i] == house then
            animstate = tostring(house)
            if house == 4 then
                animstate = "16"
            elseif house == 12 then
                animstate = "7"
            else
                animstate = tostring(house)
            end 
            break
        end
    end
    viewer.changeObjState(animationID,animstate)
end
function obj_firetrucks_manager:endAnimation(house,car_num)
    viewer.changeObjState(houses[house],"disappear")
    viewer.setObjParamI(houses[house],"pow",100)
    local zero = "fires.house"..house
    viewer.setOptParamI(zero,0,1)
    if car_num == 1 then
        viewer.changeObjState(56539,"animate_first")
        viewer.changeObjState(53305,"end_anim")
        viewer.changeObjState(52889,"idle")
        viewer.changeObjState(52889,"move_to_smooth") 
    else
        viewer.changeObjState(56539,"animate_second")
        viewer.changeObjState(55501,"end_anim")
        viewer.changeObjState(55496,"idle")
        viewer.changeObjState(55496,"move_to_smooth")
    end
end
function obj_firetrucks_manager:init()
    nodes =           -- ноды домов от 1 до 20
            {
                361,365,367,357,358,
                368,359,360,366,381,
                376,375,374,355,354,
                373,372,371,370,369,
            }
    houses =          -- айдишники домов от 1 до 20
            {
                52937,53298,52901,52915,52903,
                52905,52907,52909,52911,52913,
                52917,52919,52921,52923,52925,
                52927,52929,52931,52933,52935,
            }
    car1 = 0    -- цель для наших пожарных
    car2 = 0    
    queue = {}  -- очередь пожаротушения
end

obj_hhlpbg_expert = class() 
function obj_hhlpbg_expert:state(state,guestID)
    if 	(state == "open") then
		open()
	end
  	function open()
        local time = viewer.getOptParamI("ecomics21.ittimes.itm8445",0,1)
        local numdays = math.floor(time/86400000)
        local numhours = math.floor(time/3600000)
        viewer.setObjParamI(33627,"quick_expert_numdays",numdays)
        viewer.setObjParamI(33627,"quick_expert_numhours",numhours)
  	end
end                                          

obj_ks_holly_random = class() 
local cubeDots = {
    46598,46599,46600,
    46601,46602,46603,
    46605,46606,46607,
    46608,46609,46610,
    46621,46622,46623,
    46624,46625,46626,
    46628,46629,46630,
    46631,46632,46633
  }
local first_win1;
local first_win2;
local win_after_three_defeats;
function obj_ks_holly_random:state(state,guestID)
	if 	(state == "enemy") then
        local e_c1;
        local e_c2;
        if(viewer.getObjParamI(46, "p0.mg_kosti.first_win", 0) > 0 and viewer.getObjParamI(46, "p0.mg_kosti.four_defeats", 0) <= 3 ) then
            e_c1 = math.random(6);
            e_c2 = math.random(6);
        else
            e_c1 = math.random(6);
            e_c2 = math.random(5);
        end
        first_win1 = e_c1
        first_win2 = e_c2;
        viewer.setObjParamF(cubeDots[e_c1], "al", 1);
        viewer.setObjParamF(cubeDots[6 + e_c2], "al", 1);
        viewer.setObjParamI(46, "enemy_N", e_c1 + e_c2);
        viewer.setObjParamI(46688, "val", e_c1 + e_c2);
        viewer.changeObjState(46672, "init");
        viewer.changeObjState(46677, "init");
        viewer.changeObjState(46688, "init");
        viewer.changeObjState(46671, "show");
	end
    if (state == "player") then
        local p_c1;
        local p_c2;
        if(viewer.getObjParamI(46, "p0.mg_kosti.first_win", 0) > 0 and viewer.getObjParamI(46, "p0.mg_kosti.four_defeats", 0) <= 3) then
            p_c1 = math.random(6);
            p_c2 = math.random(6);   
        else
            p_c1 = math.random(first_win1, 6);
            p_c2 = math.random(first_win2, 6); 
            viewer.setObjParamI(46, "p0.mg_kosti.four_defeats", 0);
        end
        viewer.setObjParamF(cubeDots[12 + p_c1], "al", 1.0);
        viewer.setObjParamF(cubeDots[18 + p_c2], "al", 1.0);
        viewer.setObjParamI(46, "player_N", p_c1 + p_c2);
        viewer.setObjParamI(46684, "val", p_c1 + p_c2);
        viewer.changeObjState(46676, "init");
        viewer.changeObjState(46684, "init");
	end
    if (state == "check_win") then
        local e_sum = viewer.getObjParamI(46, "enemy_N", 0);
        local p_sum = viewer.getObjParamI(46, "player_N",0);
        if(e_sum > p_sum)then
            viewer.changeObjState(46567, "lose");
        end
        if(e_sum == p_sum) then
            viewer.changeObjState(46567, "draw");
            viewer.changeObjState(46675, "show");
        end
        if(e_sum < p_sum) then
            viewer.changeObjState(46567, "win");
        end
    else
        return;
    end
end

obj_m_bandit_path_num = class() 
function obj_m_bandit_path_num:init()
    self.bandPath_array={}
    viewer.changeObjState(34109,"init")
end
function swap(humPath_array, index1, index2)
    humPath_array[index1], humPath_array[index2] = humPath_array[index2], humPath_array[index1]
end
function shuffle(array)
    local counter = #array
    while counter > 1 do
        local index = math.random(counter)
        swap(array, index, counter)
        counter = counter - 1
    end
end
function obj_m_bandit_path_num:checkPath()
    self.bandPath_array=viewer.getOptParamArrI("band_array",1)
    if (#self.bandPath_array==0) then
        self.bandPath_array={1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18}
        viewer.setOptParamArrI("band_array",self.bandPath_array,1)
    end
    shuffle(self.bandPath_array)
    viewer.changeObjState(33873,"path_"..self.bandPath_array[1])
    table.remove(self.bandPath_array,1)
    viewer.setOptParamArrI("band_array",self.bandPath_array,1)
end
function obj_m_bandit_path_num:endPath()
    local guest_ID=viewer.getObjParamI(33872,"guestID",228) 
    local insert_path=viewer.getObjParamI(guest_ID,"path_num",322)
    table.insert(self.bandPath_array,insert_path)
    viewer.setOptParamArrI("band_array",self.bandPath_array,1)
end                                                  

obj_m_car_path_num = class()
function obj_m_car_path_num:init()
  self.carPath_array={}
  viewer.changeObjState(34109,"init")
end
function swap(carPath_array, index1, index2)
    carPath_array[index1], carPath_array[index2] = carPath_array[index2], carPath_array[index1]
end
function shuffle(array)
    local counter = #array
    while counter > 1 do
        local index = math.random(counter)
        swap(array, index, counter)
        counter = counter - 1
    end
end
function obj_m_car_path_num:checkPath()
    self.carPath_array=viewer.getOptParamArrI("car_array",1)
    if (#self.carPath_array==0) then
        self.carPath_array={1,2,3,4,5,6}
        viewer.setOptParamArrI("car_array",self.carPath_array,1)
    end
    shuffle(self.carPath_array)
    viewer.changeObjState(49373,"path_"..self.carPath_array[1])
    table.remove(self.carPath_array,1)
    viewer.setOptParamArrI("car_array",self.carPath_array,1)
end
function obj_m_car_path_num:endPath()
    local guest_ID=viewer.getObjParamI(49372,"guestID",228) 
    local insert_path=viewer.getObjParamI(guest_ID,"path_num",322)
    table.insert(self.carPath_array,insert_path)
    viewer.setOptParamArrI("car_array",self.carPath_array,1)
end

obj_m_human_path_num = class()
function obj_m_human_path_num:init()
  self.humPath_array={}
end 
function swap(humPath_array, index1, index2)
    humPath_array[index1], humPath_array[index2] = humPath_array[index2], humPath_array[index1]
end
function shuffle(array)
    local counter = #array
    while counter > 1 do
        local index = math.random(counter)
        swap(array, index, counter)
        counter = counter - 1
    end
end
function obj_m_human_path_num:checkPath()
    self.humPath_array=viewer.getOptParamArrI("human_array",1)
    if (#self.humPath_array==0) then
        self.humPath_array={1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22}
        viewer.setOptParamArrI("human_array",self.humPath_array,1)
    end
    shuffle(self.humPath_array)
    viewer.changeObjState(33868,"path_"..self.humPath_array[1])
    table.remove(self.humPath_array,1)
    viewer.setOptParamArrI("human_array",self.humPath_array,1)
end
function obj_m_human_path_num:endPath()
    local guest_ID = viewer.getObjParamI(33867,"guestID",228)    
    local insert_path = viewer.getObjParamI(guest_ID,"path_num",322)
    table.insert(self.humPath_array,insert_path)
    viewer.setOptParamArrI("human_array",self.humPath_array,1)
end

obj_m_set_bandit_path = class()
function obj_m_set_bandit_path:init()
    self.humanStack={}
    self.allBandRun={}
    self.allBandEnd={} 
end
function obj_m_set_bandit_path:state(state,guestID)
    if (state=="rand") then
        local guest_ID=viewer.getObjParamI(33872,"guestID",228)
        table.insert(self.humanStack,guest_ID)
        while (#self.humanStack>0) do
            local setPath="setPath_"..self.humanStack[1]
            local pathNum=viewer.getObjParamI(33872,setPath,0)
            pathNum=pathNum+1
            viewer.setObjParamI(33872,setPath,pathNum)
            if (pathNum>=3) then
                viewer.changeObjState(33872,"end")
                obj_m_bandit_path_num:endPath()
                viewer.setObjParamI(self.humanStack[1],"al",0)
                viewer.setObjParamI(self.humanStack[1],"y",2000)
                pathNum=0
                table.insert(self.allBandEnd,guest_ID)
                viewer.setOptParamArrI("allBandEnd",self.allBandEnd,1)            
            elseif (pathNum==2) then
                viewer.changeObjState(33872,"move_to_smooth")
                local moveTO=viewer.getObjParamI(self.humanStack[1],"finish_fin",15)
                viewer.setObjParamI(self.humanStack[1],"finish",moveTO)
                viewer.changeObjState(self.humanStack[1],"move_to_smooth")
            else
                table.insert(self.allBandRun,guest_ID)
                viewer.setOptParamArrI("allBandRun",self.allBandRun,1)
                viewer.changeObjState(33872,"move")
                obj_m_bandit_path_num:checkPath()
                viewer.setObjParamI(self.humanStack[1],"al",1)
            end 
            if (#self.humanStack>0) then
                table.remove(self.humanStack,1)
            end
        end
    end
    if (state=="fail") then
        local guest_ID=viewer.getObjParamI(33872,"guestID",228)
        table.insert(self.humanStack,guest_ID)
        viewer.changeObjState(33872,"end")
        obj_m_bandit_path_num:endPath()
        viewer.setObjParamI(self.humanStack[1],"al",0)
        viewer.setObjParamI(self.humanStack[1],"y",2000)
        pathNum=0
        table.insert(self.allBandEnd,guest_ID)
        viewer.setOptParamArrI("allBandEnd",self.allBandEnd,1)     
        local setPath="setPath_"..self.humanStack[1]
        viewer.setObjParamI(33872,setPath,0)
        table.remove(self.humanStack,1)
    end
end

obj_m_set_car_path = class()
function obj_m_set_car_path:init()
  self.carStack={}
  self.allcarRun={}
  self.allcarEnd={}
end
function obj_m_set_car_path:state(state,guestID)
    if (state=="rand") then
    end
    if (state=="fail") then
        viewer.setObjParamI(guest_ID, "y", 2000)
    end
end

obj_m_set_human_path = class()
function obj_m_set_human_path:init()
    self.humanStack={}
    self.allHumRun={}
    self.allHumEnd={}
end 
function obj_m_set_human_path:state(state,guestID)
    if (state=="rand") then
        obj_m_set_human_path:rand()
    end
    if (state=="fail") then
        obj_m_set_human_path:fail(guestID)
    end
end
function obj_m_set_human_path:end_fail(guestID)
    local guest_ID = guestID --viewer.getObjParamI(33867,"guestID",228)
    local guest_param = viewer.getObjParamI(33867,viewer.getObjParamS(guest_ID,"path_num",""),"param")
    local walking_humans = viewer.getObjParamI(33866,"walking_humans",0)-1
    viewer.setObjParamI(33867,"guest",guest_ID)
    viewer.setObjParamI(guest_ID,"al",0)
    viewer.setObjParamI(33867,"setPath_"..guest_ID,0)
    viewer.setObjParamS(33867,"path_num",viewer.getObjParamS(guest_ID,"path_num",""))
    viewer.changeObjState(33868,"end")
    viewer.setObjParamI(33869,"guest_param",0)
    viewer.setObjParamI(33866,"walking_humans",walking_humans)
end
function obj_m_set_human_path:rand()
    local guest_ID=viewer.getObjParamI(33867,"guestID",228)
    table.insert(self.humanStack,guest_ID)
    while (#self.humanStack>0) do
        local setPath="setPath_"..self.humanStack[1]
        local pathNum=viewer.getObjParamI(33867,setPath,0)
        pathNum=pathNum+1
        viewer.setObjParamI(33867,setPath,pathNum)
        if (pathNum>=3) then
            obj_m_set_human_path:end_fail(guest_ID)
            obj_m_human_path_num:endPath()
            viewer.setObjParamI(self.humanStack[1],"al",0)
            viewer.setObjParamI(self.humanStack[1],"y",2000)
            pathNum=0
            table.insert(self.allHumEnd,guest_ID)
            viewer.setOptParamArrI("allHumEnd",self.allHumEnd,1)      
        elseif (pathNum==2) then
            viewer.changeObjState(33867,"move_to_smooth")
            local moveTO=viewer.getObjParamI(self.humanStack[1],"finish_fin",15)
            viewer.setObjParamI(self.humanStack[1],"finish",moveTO)
            viewer.changeObjState(self.humanStack[1],"move_to_smooth")
        else
            table.insert(self.allHumRun,guest_ID)
            viewer.setOptParamArrI("allHumRun",self.allHumRun,1)
            viewer.setObjParamI(guest_ID,"al",1)
            obj_m_human_path_num:checkPath()
            viewer.setObjParamI(self.humanStack[1],"al",1)
        end 
        if (#self.humanStack>0) then
            table.remove(self.humanStack,1)
        end
    end
end
function obj_m_set_human_path:fail(guestID)
    local guest_ID=guestID   --viewer.getObjParamI(33867,"guestID",228)
    table.insert(self.humanStack,guest_ID)
    obj_m_set_human_path:end_fail(guestID)
    obj_m_human_path_num:endPath()
    viewer.setObjParamI(self.humanStack[1],"al",0)
    viewer.setObjParamI(self.humanStack[1],"y",2000)
    pathNum=0
    table.insert(self.allHumEnd,guest_ID)
    viewer.setOptParamArrI("allHumEnd",self.allHumEnd,1) 
    local setPath="setPath_"..self.humanStack[1]
    viewer.setObjParamI(33867,setPath,0)
    table.remove(self.humanStack,1)
end

obj_mg_deal_control = class()
header = {
  {9917,9918,9922},       -- кейс 1
  {9966,9967,9968},       -- кейс 2
  {9992,9993,9994},       -- кейс 3
  {10014,10015,10016},    -- кейс 4
  {10036,10037,10038},    -- кейс 5
  {10059,10060,10061},    -- кейс 6
  {10081,10082,10083},    -- кейс 7
  {10103,10104,10105},    -- кейс 8
  {10125,10126,10127},    -- кейс 9
  {10147,10148,10149},    -- кейс 10
  {10169,10170,10171},    -- кейс 11
  {10191,10192,10193},    -- кейс 12
  {10213,10214,10215},    -- кейс 13
  {10235,10236,10237},    -- кейс 14
  {10257,10258,10259},    -- кейс 15
  {10288,10289,10290},    -- кейс 16
  {-1,-1,-1},    -- кейс 17 - не в работе
  {-1,-1,-1},    -- кейс 18 - не в работе
  {-1,-1,-1},    -- кейс 19 - не в работе
  {-1,-1,-1},    -- кейс 20 - не в работе
  {10722,10723,10724},    -- ивентовый кейс 1
  {10895,10896,10897},    -- ивентовый кейс 2
  {11017,11018,11019},    -- ивентовый кейс 3
  {-1,-1,-1},    -- ивентовый кейс 4
  {11138,11139,11140},    -- ивентовый кейс 5
}
facts = {
  {step1 = {9911, 9912, 9913}, step2 = {9919, 9920, 9921}, step3 = {9923, 9924, 9925}},             -- кейс 1
  {step1 = {9956, 9957, 9958}, step2 = {9959, 9960, 9961}, step3 = {9962, 9963, 9964}},             -- кейс 2
  {step1 = {9982, 9983, 9984}, step2 = {9985, 9986, 9987}, step3 = {9988, 9989, 9990}},             -- кейс 3
  {step1 = {10004, 10005, 10006}, step2 = {10007, 10008, 10009}, step3 = {10010, 10011, 10012}},    -- кейс 4
  {step1 = {10026, 10027, 10028}, step2 = {10029, 10030, 10031}, step3 = {10032, 10033, 10034}},    -- кейс 5
  {step1 = {10049, 10050, 10051}, step2 = {10052, 10053, 10054}, step3 = {10055, 10056, 10057}},    -- кейс 6
  {step1 = {10072, 10073, 10074}, step2 = {10075, 10076, 10077}, step3 = {10078, 10079, 10080}},    -- кейс 7
  {step1 = {10093, 10094, 10095}, step2 = {10096, 10097, 10098}, step3 = {10099, 10100, 10101}},    -- кейс 8
  {step1 = {10115, 10116, 10117}, step2 = {10118, 10119, 10120}, step3 = {10121, 10122, 10123}},    -- кейс 9
  {step1 = {10137,10138,10139}, step2 = {10140,10141,10142}, step3 = {10143,10144,10145}},          -- кейс 10
  {step1 = {10159,10160,10161}, step2 = {10162,10163,10164}, step3 = {10165,10166,10167}},          -- кейс 11
  {step1 = {10181,10182,10183}, step2 = {10184,10185,10186}, step3 = {10187,10188,10189}},          -- кейс 12
  {step1 = {10203,10204,10205}, step2 = {10206,10207,10208}, step3 = {10209,10210,10211}},          -- кейс 13
  {step1 = {10225,10226,10227}, step2 = {10228,10229,10230}, step3 = {10231,10232,10233}},          -- кейс 14
  {step1 = {10247,10248,10249}, step2 = {10250,10251,10252}, step3 = {10253,10254,10255}},          -- кейс 15
  {step1 = {10269,10270,10271}, step2 = {10272,10273,10274}, step3 = {10275,10276,10277}},          -- кейс 16
  {step1 = {-1,-1,-1}, step2 = {-1,-1,-1}, step3 = {-1,-1,-1}},          -- кейс 17 - не в работе
  {step1 = {-1,-1,-1}, step2 = {-1,-1,-1}, step3 = {-1,-1,-1}},          -- кейс 18 - не в работе
  {step1 = {-1,-1,-1}, step2 = {-1,-1,-1}, step3 = {-1,-1,-1}},          -- кейс 19 - не в работе
  {step1 = {-1,-1,-1}, step2 = {-1,-1,-1}, step3 = {-1,-1,-1}},          -- кейс 20 - не в работе
  {step1 = {10712,10713,10714}, step2 = {10715,10716,10717}, step3 = {10718,10719,10720}},          -- ивентовый кейс 1
  {step1 = {10898,10899,10900}, step2 = {10901,10902,10903}, step3 = {10904,10905,10906}},          -- ивентовый кейс 2
  {step1 = {11007,11008,11009}, step2 = {11010,11011,11012}, step3 = {11013,11014,11015}},          -- ивентовый кейс 3
  {step1 = {-1,-1,-1}, step2 = {-1,-1,-1}, step3 = {-1,-1,-1}},        -- ивентовый кейс 4
  {step1 = {11128,11129,11130}, step2 = {11131,11132,11133}, step3 = {11134,11135,11136}},          -- ивентовый кейс 5
}
 Ar_IdObjs = {
      fact1={53649,53650},
      fact2={53657,53658},
      fact3={53666,53667},
 }
 checks = {53652,53660,53669}
  lies = {
    {step1 = {0, 0, 1}, step2 = {1, 0, 0}, step3 = {0, 1, 0}},      -- кейс 1
    {step1 = {1, 0, 0}, step2 = {0, 0, 1}, step3 = {0, 1, 0}},      -- кейс 2
    {step1 = {0, 0, 1}, step2 = {0, 1, 0}, step3 = {1, 0, 0}},      -- кейс 3
    {step1 = {1, 0, 0}, step2 = {0, 0, 1}, step3 = {0, 0, 1}},      -- кейс 4
    {step1 = {1, 0, 0}, step2 = {0, 1, 0}, step3 = {0, 1, 0}},      -- кейс 5
    {step1 = {0, 1, 0}, step2 = {1, 0, 0}, step3 = {0, 0, 1}},      -- кейс 6
    {step1 = {1, 0, 0}, step2 = {1, 0, 0}, step3 = {0, 0, 1}},      -- кейс 7
    {step1 = {1, 0, 0}, step2 = {0, 1, 0}, step3 = {1, 0, 0}},      -- кейс 8
    {step1 = {0, 0, 1}, step2 = {0, 1, 0}, step3 = {1, 0, 0}},      -- кейс 9
    {step1 = {0, 0, 1}, step2 = {0, 1, 0}, step3 = {0, 0, 1}},      -- кейс 10
    {step1 = {0, 1, 0}, step2 = {1, 0, 0}, step3 = {1, 0, 0}},      -- кейс 11 
    {step1 = {0, 0, 1}, step2 = {0, 1, 0}, step3 = {0, 0, 1}},      -- кейс 12
    {step1 = {0, 1, 0}, step2 = {1, 0, 0}, step3 = {0, 1, 0}},      -- кейс 13
    {step1 = {0, 1, 0}, step2 = {1, 0, 0}, step3 = {1, 0, 0}},      -- кейс 14
    {step1 = {0, 0, 1}, step2 = {1, 0, 0}, step3 = {0, 1, 0}},      -- кейс 15
    {step1 = {1, 0, 0}, step2 = {0, 1, 0}, step3 = {0, 0, 1}},      -- кейс 16
    {step1 = {0, 0, 0}, step2 = {0, 0, 0}, step3 = {0, 0, 0}},      -- кейс 17 - не в работе
    {step1 = {0, 0, 0}, step2 = {0, 0, 0}, step3 = {0, 0, 0}},      -- кейс 18 - не в работе
    {step1 = {0, 0, 0}, step2 = {0, 0, 0}, step3 = {0, 0, 0}},      -- кейс 19 - не в работе
    {step1 = {0, 0, 0}, step2 = {0, 0, 0}, step3 = {0, 0, 0}},      -- кейс 20 - не в работе
    {step1 = {0, 0, 1}, step2 = {0, 0, 1}, step3 = {1, 0, 0}},      -- ивентовый кейс 1
    {step1 = {1, 0, 0}, step2 = {0, 1, 0}, step3 = {0, 1, 0}},      -- ивентовый кейс 2
    {step1 = {0, 0, 1}, step2 = {1, 0, 0}, step3 = {1, 0, 0}},      -- ивентовый кейс 3
    {step1 = {1, 1, 1}, step2 = {1, 1, 1}, step3 = {1, 1, 1}},      -- ивентовый кейс 4
    {step1 = {1, 1, 1}, step2 = {1, 1, 1}, step3 = {1, 1, 1}},      -- ивентовый кейс 5
  }
  cases = {
            9916,       -- кейс 1
            9965,       -- кейс 2
            9991,       -- кейс 3
            10013,      -- кейс 4
            10035,      -- кейс 5
            10058,      -- кейс 6
            10071,      -- кейс 7
            10102,      -- кейс 8
            10124,      -- кейс 9
            10146,      -- кейс 10
            10168,      -- кейс 11
            10190,      -- кейс 12
            10212,      -- кейс 13
            10234,      -- кейс 14
            10256,      -- кейс 15
            10278,      -- кейс 16
            -1,      -- кейс 17 - не в работе
            -1,      -- кейс 18 - не в работе
            -1,      -- кейс 19 - не в работе
            -1,      -- кейс 20 - не в работе
            10721,      -- ивентовый кейс 1
            10916,      -- ивентовый кейс 2
            11016,      -- ивентовый кейс 3
            -1,      -- ивентовый кейс 4
            11137,      -- ивентовый кейс 5
           }
 criminal = {
                6499,       -- кейс 1
                6363,       -- кейс 2
                6665,       -- кейс 3
                10415,      -- кейс 4
                6878,       -- кейс 5
                10416,      -- кейс 6
                7195,       -- кейс 7
                7201,       -- кейс 8
                7695,       -- кейс 9
                7201,       -- кейс 10
                8647,       -- кейс 11
                8897,       -- кейс 12
                10417,      -- кейс 13
                9095,       -- кейс 14
                9197,       -- кейс 15
                9720,       -- кейс 16
                -1,      -- кейс 17 - не в работе
                -1,      -- кейс 18 - не в работе
                -1,      -- кейс 19 - не в работе
                -1,      -- кейс 20 - не в работе
                10756,      -- ивентовый кейс 1
                10878,      -- ивентовый кейс 2
                11042,      -- ивентовый кейс 3
                -1,      -- ивентовый кейс 4
                11089,      -- ивентовый кейс 5
   }
 congrats_txt = {7296, 9937, 9938, 9939}
 right_wrong_txt = {
   {step1 = {9941, 9942, 9943}, step2 = {9944, 9945, 9946}, step3 = {9947, 9948, 9949}},           -- кейс 1
   {step1 = {9969, 9970, 9971}, step2 = {9972, 9973, 9974}, step3 = {9975, 9976, 9977}},           -- кейс 2
   {step1 = {9995, 9996, 9997}, step2 = {9998, 9999, 10000}, step3 = {10001, 10002, 10003}},       -- кейс 3
   {step1 = {10017, 10018, 10019}, step2 = {10020, 10021, 10022}, step3 = {10023, 10024, 10025}},  -- кейс 4
   {step1 = {10039, 10040, 10041}, step2 = {10042, 10043, 10044}, step3 = {10045, 10046, 10047}},  -- кейс 5
   {step1 = {10062, 10063, 10064}, step2 = {10065, 10066, 10067}, step3 = {10068, 10069, 10070}},  -- кейс 6
   {step1 = {10084, 10085, 10086}, step2 = {10087, 10088, 10089}, step3 = {10090, 10091, 10092}},  -- кейс 7
   {step1 = {10106, 10107, 10108}, step2 = {10109, 10110, 10111}, step3 = {10112, 10113, 10114}},  -- кейс 8
   {step1 = {10128, 10129, 10130}, step2 = {10131, 10132, 10133}, step3 = {10134, 10135, 10136}},  -- кейс 9
   {step1 = {10150,10151,10152}, step2 = {10153,10154,10155}, step3 = {10156,10157,10158}},        -- кейс 10
   {step1 = {10172,10173,10174}, step2 = {10175,10176,10177}, step3 = {10178,10179,10180}},        -- кейс 11
   {step1 = {10194,10195,10196}, step2 = {10197,10198,10199}, step3 = {10200,10201,10202}},        -- кейс 12
   {step1 = {10216,10217,10218}, step2 = {10219,10220,10221}, step3 = {10222,10223,10224}},        -- кейс 13
   {step1 = {10238,10239,10240}, step2 = {10241,201242,10243}, step3 = {10244,10245,10246}},       -- кейс 14
   {step1 = {10260,10261,10262}, step2 = {10263,10264,10265}, step3 = {10266,10267,10268}},        -- кейс 15
   {step1 = {10279,10280,10281}, step2 = {10282,10283,10284}, step3 = {10285,10286,10287}},        -- кейс 16
   {step1 = {-1,-1,-1}, step2 = {-1,-1,-1}, step3 = {-1,-1,-1}},          -- кейс 17 - не в работе
   {step1 = {-1,-1,-1}, step2 = {-1,-1,-1}, step3 = {-1,-1,-1}},          -- кейс 18 - не в работе
   {step1 = {-1,-1,-1}, step2 = {-1,-1,-1}, step3 = {-1,-1,-1}},          -- кейс 19 - не в работе
   {step1 = {-1,-1,-1}, step2 = {-1,-1,-1}, step3 = {-1,-1,-1}},          -- кейс 20 - не в работе
   {step1 = {10725,10726,10727}, step2 = {10728,10729,10730}, step3 = {10731,10732,10733}},          -- ивентовый кейс 1
   {step1 = {10907,10908,10909}, step2 = {10910,10911,10912}, step3 = {10913,10914,10915}},          -- ивентовый кейс 2
   {step1 = {11020,11021,11022}, step2 = {11023,11024,11025}, step3 = {11026,11027,11028}},          -- ивентовый кейс 3
   {step1 = {-1,-1,-1}, step2 = {-1,-1,-1}, step3 = {-1,-1,-1}},          -- ивентовый кейс 4
   {step1 = {11141,11142,11143}, step2 = {11144,11145,11146}, step3 = {11147,11148,11149}},          -- ивентовый кейс 5
 }
 skip = {
            7614,       -- кейс 1
            7615,       -- кейс 2
            7616,       -- кейс 3
            7617,       -- кейс 4
            7618,       -- кейс 5
            7619,       -- кейс 6
            7620,       -- кейс 7
            7621,       -- кейс 8
            8081,       -- кейс 9
            8625,       -- кейс 10
            8740,       -- кейс 11
            8859,       -- кейс 12
            8973,       -- кейс 13
            9110,       -- кейс 14
            9277,       -- кейс 15
            9789,       -- кейс 16
            -1,      -- кейс 17 - не в работе
            -1,      -- кейс 18 - не в работе
            -1,      -- кейс 19 - не в работе
            -1,      -- кейс 20 - не в работе
            10743,       -- ивентовый кейс 1
            10917,       -- ивентовый кейс 2
            11029,       -- ивентовый кейс 3
            -1,       -- ивентовый кейс 4
            11150,       -- ивентовый кейс 5
         }
 checkbox = {fact1={53656,53852},
             fact2={53665,53648},
             fact3={53818,53686}
    }
step_texts = {9915,10299,10300}
function obj_mg_deal_control:start()
    viewer.setObjParamI(40, "al", 0)
    viewer.setOptParamI("flurry.skipped_mg", 0, 1)
    viewer.setOptParamI("flurry.mg_id", 4, 1)
    viewer.changeObjState(41934, "case_mg_start")
    local num_case = viewer.getOptParamI("num_case", 1, 1)
    if num_case > 900 then
        local num_case_event = viewer.getOptParamI("num_case_event", 1, 1)
        num_case = 20 + num_case_event
    end
    local step_num = viewer.getOptParamI("finish_case.step_num", 1, 1)
    if(step_num == 4 or step_num == 0)then
        viewer.setOptParamI("finish_case.step_num", 1, 1)
        step_num = 1
    end
    if(step_num == 3 or step_num == 2)then
        viewer.changeObjState(checkbox["fact"..1][1], "on")
        if(step_num == 3)then
            viewer.changeObjState(checkbox["fact"..2][1], "on")
        end
    end
    viewer.setObjParamS(26112, "txtID", cases[num_case])
    viewer.changeObjState(26112, "init")
    obj_mg_deal_control:change_graphics()
end
function obj_mg_deal_control:check()
    local num_case = viewer.getOptParamI("num_case", 1, 1)
    if num_case > 900 then
        local num_case_event = viewer.getOptParamI("num_case_event", 1, 1)
        num_case = 20 + num_case_event
    end
    local choice = viewer.getObjParamI(53603, "choice", 0)
    local step_num = viewer.getOptParamI("finish_case.step_num", 1, 1)
    if(lies[num_case]["step"..step_num][choice] == 1)then
        viewer.changeObjState(checkbox["fact"..step_num][2], "init")
        viewer.changeObjState(checkbox["fact"..step_num][1], "on")
        viewer.changeObjState(checks[choice], "on")
        local congrats = math.random(4)
        if((step_num + 1) == 4)then
            viewer.changeObjState(30610, "down")
            viewer.setObjParamI(54166, "txtID", congrats_txt[congrats])
            viewer.changeObjState(54166, "init")
            local criminal_case = viewer.getResFromTxtDB(criminal[num_case],1,666)
            viewer.setObjParamI(53778, "res", criminal_case)
            viewer.changeObjState(53778, "init")
            viewer.setObjParamI(53704, "txtID", right_wrong_txt[num_case]["step"..3][choice])
            viewer.changeObjState(53704, "init")
            viewer.changeObjState(53680, "open")
            if (num_case < 21) then
                viewer.setOptParamI("finish_case.win_deal"..num_case,1,1)
            else
                local num_case_event = viewer.getOptParamI("num_case_event", 1, 1)
                viewer.setOptParamI("finish_case.win_deal_event"..num_case_event,1,1)
            end
        else
            viewer.setObjParamI(53742, "txtID", congrats_txt[congrats])
            viewer.changeObjState(53742, "init")
            viewer.setObjParamI(53737,"txtID", right_wrong_txt[num_case]["step"..step_num][choice])
            viewer.changeObjState(53737, "init")
            viewer.changeObjState(53713, "open")
            local tut = viewer.getOptParamI("tasks9921.t9953.s",0,1)
            local state = viewer.getObjState(24226)
            if(viewer.getOptParamI("tasks9921.t9953.s",0,1) ~= 3)then
                viewer.changeObjState(26343, "end")
            end
            if((viewer.getOptParamI("tasks9921.t9934.s",0,1)) ~= 3 and step_num == 2)then
                viewer.changeObjState(24226, "finish_case_2_end")
            end
        end
        step_num = step_num+1  
        else--Неправильный вариант
        if(viewer.getOptParamI("tasks9921.t9934.s",0,1) == 3)then
            viewer.changeObjState(checkbox["fact"..step_num][2], "on")
            viewer.setObjParamI(53773,"txtID", right_wrong_txt[num_case]["step"..step_num][choice])
            viewer.changeObjState(53773, "init")
            viewer.changeObjState(checks[choice], "on")
            viewer.changeObjState(53749, "open")
        end
    end
    viewer.setOptParamI("finish_case.step_num", step_num, 1)
end
function obj_mg_deal_control:change_graphics()
    local num_case = viewer.getOptParamI("num_case", 1, 1)
    if num_case > 900 then
        local num_case_event = viewer.getOptParamI("num_case_event", 1, 1)
        num_case = 20 + num_case_event
    end
    local step_num = viewer.getOptParamI("finish_case.step_num", 1, 1)
    viewer.setObjParamI(53803, "al", 1)
    viewer.changeObjState(53803, "init")
    local header_txt = header[num_case][step_num]
    local header_res = viewer.getResFromTxtDB(header_txt,2,666)
    viewer.setObjParamI(53641, "res", header_res)
    viewer.setObjParamI(53644, "txtID", header_txt)
    viewer.changeObjState(54228, "init")
    for i=1,3 do
        local fact = facts[num_case]["step"..step_num][i]
        local res = viewer.getResFromTxtDB(fact,2,666)
        viewer.setObjParamI(Ar_IdObjs["fact"..i][2], "txtID", fact)
        viewer.setObjParamI(Ar_IdObjs["fact"..i][1],"res", res)
        viewer.changeObjState(Ar_IdObjs["fact"..i][2], "init")
        viewer.changeObjState(Ar_IdObjs["fact"..i][1], "init")
    end
    if(viewer.getOptParamI("tasks9921.t9953.s",0,1) == 3)then
        viewer.changeObjState(24661, "up")
    end
    viewer.setObjParamI(53642, "txtID", step_texts[step_num])
    viewer.changeObjState(53642, "init")
    if (viewer.getObjState(24226) == "finish_case_2_end") then
        viewer.changeObjState(24226, "finish_case_3")
        viewer.changeObjState(26350, "init")
    end
    if (num_case == 6 and step_num == 3) then
        viewer.setObjParamI(53641,"y",-255)
    end
end
function obj_mg_deal_control:help()
    local num_case = viewer.getOptParamI("num_case", 1, 1)
    if num_case > 900 then
        local num_case_event = viewer.getOptParamI("num_case_event", 1, 1)
        num_case = 20 + num_case_event
    end
    local step_num = viewer.getOptParamI("finish_case.step_num", 1, 1)
    if (lies[num_case]["step"..step_num][1] == 0)then
        viewer.setObjParamI(53646,"al",0)
    else
        local hide_fact = math.random(2)
        if(hide_fact == 1)then
            viewer.setObjParamI(53654,"al",0)
        else
            viewer.setObjParamI(53663,"al",0)
        end   
    end  
    viewer.changeObjState(24661, "disable")
    if (viewer.getObjState(24226) == "finish_case_2") then
        viewer.changeObjState(24226, "finish_case_2_end")
    end
  end 
function obj_mg_deal_control:skip()
    viewer.changeObjState(30610, "down")
    local num_case = viewer.getOptParamI("num_case", 1, 1)
    if num_case > 900 then
        local num_case_event = viewer.getOptParamI("num_case_event", 1, 1)
        num_case = 20 + num_case_event
    end
    viewer.setObjParamI(25968, "txtID", skip[num_case])
    viewer.changeObjState(25968, "init")
    viewer.changeObjState(25960, "show_skip")
    viewer.setOptParamI("finish_case.win_deal"..num_case,1,1)
    viewer.setObjParamI(55021, "txtID", criminal[num_case])
    viewer.changeObjState(55021, "init")
    local criminal_case = viewer.getResFromTxtDB(criminal[num_case],1,666)
    viewer.setObjParamI(55017, "res", criminal_case)
    viewer.changeObjState(55017, "init")
end 
function obj_mg_deal_control:check_tut()
    print("obj_mg_deal_control:state:check_tut")
    local num_case = viewer.getOptParamI("num_case", 1, 1) 
    if num_case > 900 then
        local num_case_event = viewer.getOptParamI("num_case_event", 1, 1)
        num_case = 20 + num_case_event
    end
    local step_num = viewer.getOptParamI("finish_case.step_num", 1, 1)
    local wnd_st = viewer.getObjState(53713)
    for i = 1, 3 do
    if((lies[num_case]["step"..step_num][i] == 1) and ( (wnd_st ~= "open1") or (wnd_st ~= "open_") ) )then
        viewer.setObjParamI(26350, "move", i)
        viewer.changeObjState(26350, "wait")
    end
    end
end
function obj_mg_deal_control:state(state,guestID)
    if (state == "check") then
        obj_mg_deal_control:check()
    end  
    if (state == "change_graphics") then
        obj_mg_deal_control:change_graphics()
    end  
    if (state == "help") then
        obj_mg_deal_control:help()
    end
    if (state == "skip") then
        obj_mg_deal_control:skip()
    end
    if (state == "check_tut") then
        obj_mg_deal_control:check_tut()
    end
end

obj_move_res_cargo = class() 
function obj_move_res_cargo:state(state,guestID)
	if 	(state == "check") then
		local paramCheck=viewer.getObjParamI(29748,"paramCheck",-1)
        local checkObjParam;
        for i=1,#obj_root_shuffle.arrayMachines do
            if (paramCheck == obj_root_shuffle.arrayMachines[i]) then
                checkObjParam = i
                break
            end
        end
        print ("checkObjParam = "..checkObjParam)
        local objType=viewer.getObjParamS(paramCheck,"setType",-1)
        local need_find_siluet = obj_root_shuffle.Siluets[1]
        local need_find
        for i = 1, #obj_root_shuffle.Pairs do
            if (obj_root_shuffle.Pairs[i][2] == need_find_siluet) then
                need_find = obj_root_shuffle.Pairs[i][1]
                break
            end
        end
        if (tonumber(objType)==1 and viewer.getObjParamI(paramCheck+1,"res",0) == need_find) then
            if (tonumber(obj_root_shuffle.tutorial)==1) then
                viewer.changeObjState(obj_root_shuffle.arrayMachines[checkObjParam],"rgb_w")
            else
                viewer.changeObjState(obj_root_shuffle.arrayMachines[checkObjParam],"rgb_w_tutorial")
                viewer.setOptParamI("conveyor.tut",1,1)
                viewer.changeObjState(29749,"init")
                obj_root_shuffle.tutorial=1
            end
            obj_root_shuffle.arrayMachines[checkObjParam]=-1
            obj_root_shuffle.itemsNeeded=obj_root_shuffle.itemsNeeded-1
            obj_root_shuffle.itemsFind=obj_root_shuffle.itemsFind+1
            viewer.setObjParamS(29683,"val",obj_root_shuffle.itemsFind)
            viewer.changeObjState(29683,"init")
            viewer.changeObjState(29675,"right")
            viewer.changeObjState(29692,"signal_win")
            if (tonumber(obj_root_shuffle.itemsNeeded) == 0) then
                viewer.changeObjState(29748,"win")
                viewer.setObjParamS(29748,"start_game",2)
            else
                table.remove(obj_root_shuffle.Siluets,1)
                local siluet = obj_root_shuffle.Siluets[1]
                print("new target: "..siluet)
                viewer.setObjParamI(50131,"res",siluet)
                viewer.changeObjState(50131,"init")
            end
        else
            viewer.changeObjState(obj_root_shuffle.arrayMachines[checkObjParam],"rgb_f")
            viewer.changeObjState(29675,"fail")
        end
    end
    if (state == "hint") then
        obj_root_shuffle.hint = 1
    end
    if (state == "skip") then
        viewer.changeObjState(29748,"win")
        viewer.setObjParamS(29748,"start_game",2)
    end
    if (state == "start_game") then
        local siluet = obj_root_shuffle.Siluets[1]
        viewer.setObjParamI(50131,"res",siluet)
        viewer.changeObjState(50131,"init")
    end
end

obj_namecase = class()
function obj_namecase:state(state,guestID)
    if 	(state == "MergeStr") then
		MergeStr()
    end
    function MergeStr() 
        local StrCom="ReplStr_0 ReplStr_1 ReplStr_2"
        local Str0 = viewer.getStrFromTxtDB(8283,0,"") --текст Дело №
        local Str1= viewer.getOptParamI("num_case",0,1)  --номер кейса, берем из опций num_case
        local Str2= "\""..viewer.getStrFromTxtDB(viewer.getObjParamI(24314,"txtID",0),2,"").."\""
        StrCom=string.gsub(StrCom, "ReplStr_0", Str0)
        StrCom=string.gsub(StrCom, "ReplStr_1", Str1)
        StrCom=string.gsub(StrCom, "ReplStr_2", Str2)
        viewer.setObjParamS(30015,"txt",StrCom)
        viewer.changeObjState(30015,"init")
    end
end                            

obj_pelengator_script = class()
function obj_pelengator_script:state(state,guestID)
  if (state == "check") then 
    obj_pelengator_script:check_fight()
  end
  if (state == "deactivate") then 
    obj_pelengator_script:deactivate()
  end
  if (state == "disable") then 
    obj_pelengator_script:disable()
  end
end
function obj_pelengator_script:check_fight()
    flagP = false
    for i = 1, #humansP do
        if viewer.getObjState(humansP[i]) == "acting_wait" then
            obj_pelengator_script:activate(humansP[i])
            break
        end
    end
    if flagP == false then 
        obj_pelengator_script:check_drone()
    end
end
function obj_pelengator_script:check_drone()
    local netCount = viewer.getOptParamI("eitems22.i10375",0,1)
    if netCount > 0 and viewer.getObjState(54675) == "move" then -- 54675 - айдишник машины дрона
        obj_pelengator_script:activate(54675)
    end
    if flagP == false then 
        obj_pelengator_script:check_fire()
    end
end
function obj_pelengator_script:check_fire()
    local car2 = viewer.getOptParamI("fires.firecar.bought",0,1)
    local carNotFree = false       -- параметр, который сообщает, свободна ли пожарная машина
    local carState = viewer.getObjState(52889)
    local finish = viewer.getObjParamI(52889,"finish",137)
    if ( (carState == "moving_spline") and (finish == 137) ) or (carState == "idle") then
        carNotFree = true
    end
    if car2 == 1 and carNotFree == false then
        carState = viewer.getObjState(55496)
        finish = viewer.getObjParamI(55496,"finish",137)
        if ( (carState == "moving_spline") and (finish == 137) ) or (carState == "idle") then
            carNotFree = true
        end
    end
    if carNotFree == true then
        for i = 1, #firehousesP do
            if viewer.getObjState(firehousesP[i]) == "acting_wait" then
                obj_pelengator_script:activate(firehousesP[i])
                break
            end
        end
    end
    if flagP == false then 
        obj_pelengator_script:check_healing()
    end
end
function obj_pelengator_script:check_healing()
    for i = 1, #humansP do
        local needHealing = viewer.getObjParamF(humansP[i],"pow",0) < 50
        local objX = viewer.getObjParamF(humansP[i],"x",0)
        local objY = viewer.getObjParamF(humansP[i],"y",0)
        if ((objX > -1200 and objX < 1200) and (objY > -1000 and objY < 900)) then
            if viewer.getObjState(humansP[i]) == "moving_spline" and  needHealing == true then
                obj_pelengator_script:activate(humansP[i])
                break
            end
        end
    end
    if flagP == false then 
        obj_pelengator_script:check_bandits()
    end
end
function obj_pelengator_script:check_bandits()
    for i = 1, #banditsP do
        local objX = viewer.getObjParamF(banditsP[i],"x",0)
        local objY = viewer.getObjParamF(banditsP[i],"y",0)
        if ((objX > -1200 and objX < 1200) and (objY > -1000 and objY < 900)) then
            if viewer.getObjState(banditsP[i]) == "moving_spline" then
                obj_pelengator_script:activate(banditsP[i])
                break
            end
        end
    end
    if flagP == false then
        obj_pelengator_script:check_police()
    end
end
function obj_pelengator_script:check_police()
    if (viewer.getObjState(51014) == "acting_wait") then -- 51014 - айдишник изомувера полицейского
        obj_pelengator_script:activate(51014)
    end
    if flagP == false then 
        obj_pelengator_script:check_cars()
    end   
end
function obj_pelengator_script:check_cars()
    for i = 1, #carsP do
        if viewer.getObjState(carsP[i]) == "acting_wait" then
            obj_pelengator_script:activate(carsP[i])
            break
        end
    end
    if flagP == false then 
        obj_pelengator_script:check_drone_after()
    end    
end
function obj_pelengator_script:check_drone_after()
    if viewer.getObjState(54675) == "move" then -- 54675 - айдишник машины дрона
        obj_pelengator_script:activate(54675)
    end
    if flagP == false then 
        obj_pelengator_script:deactivate()
    end  
end
function obj_pelengator_script:activate(ID)
    flagP = true
    x = viewer.getObjParamI(ID,"x",0) + 360
    if ID == 54675 then -- дополнительный сдвиг для дрона
        x = x + 50
    end
    y = viewer.getObjParamI(ID,"y",0) + 637
    local spline = "0,0,"..x..","..y
    viewer.setObjParamI(54487,"vis",1)
    viewer.setObjParamS(54487,"spl1",spline)
    viewer.changeObjState(54487,"init")
end
function obj_pelengator_script:deactivate()
    viewer.setObjParamI(54487,"vis",1)
    viewer.setObjParamS(54487,"spl1","0,0")
    viewer.changeObjState(54487,"init")
    viewer.changeObjState(54489,"common_wait")
end
function obj_pelengator_script:disable()
    viewer.setObjParamI(54487,"vis",0)
    viewer.changeObjState(54487,"init")
    viewer.changeObjState(54489,"init")
end
function obj_pelengator_script:init()
    flagP = false -- индикатор занятости пеленгатора
    banditsP =   {               -- массив бандитов
                33887,33888,33889,33890,33891,33892,33893,33894,33895,
                38265,  -- туториальный бандит
            }
    humansP =    {               -- массив людей
                33875,33876,33877,33878,33879,33880,33881,33882,33883,33884,33885,33886,
                }
    carsP =      {               -- массив машин
                49364,49365,49366,49367,49368,49369
                }   
    firehousesP = {              -- массив горящих домов
                52937,53298,52901,52915,52903,52905,52907,52909,52911,52913,
                52917,52919,52921,52923,52925,52927,52929,52931,52933,52935,
                } 
end 

obj_press_case_previews_m = class() 
function obj_press_case_previews_m:state(state,guestID)
    if (state == "press") then
        press()
    end
    function press()
        local press = viewer.getObjParamI(46726,"id_press_case",0)
        viewer.changeObjState(press,"on")
    end
 end

obj_public_loc = class()
function obj_public_loc:state(state,guestID)
    local result = 0
	if 	(state == "set") then
		for i = 0, 25 do
            local strLoc = "ecomics21.loc"..i..".un"
            if viewer.GetOptParamI(strLoc,1,0) == 1 then
                result = result + 1
            end
        end
        viewer.setOptParamI("public.EconomicsUnLoc",result,1)
        viewer.changeObjState(31075,"loc")
	end
end

obj_replay_case = class()
case_tasks = 
    {
        {},
        {6345,6344,6343,6342,10396,6341,6340,6339,6338,6337,6336,6335,6334,62},
        {6472,6712,6681,6680,6679,6678,6677,6676,6674,6672,6668,6667,10400,6661,6651,10398,6650,6647,6646,6643,6640,6639,6637,6636,6633,6473},
        {6715,6773,6772,6771,6770,6769,6768,6766,6767,10404,6764,6761,6760,6754,6753,6752,6749,6746,6745,6744,6740,6738,6737,6734,6727,6725,6722,6719,6718,6716,6714,10401},
        {6850,6912,6911,6910,6909,6908,6907,6906,6905,6904,6903,6902,6901,6877,6876,6873,6871,6870,6866,6863,6861,6859,6855,6853,6852},
        {6941,6984,6983,6982,6981,10406,7046,6977,6978,6976,6975,6974,6973,6972,6971,6969,6968,6966,6965,6963,6980,6979,6962,6960,6959,6958,6956,6955,6953,6951,6950,6949,6946,6943,6942,10405,6939},
        {7154,7184,7182,7183,7181,7180,7179,7178,7177,7176,7175,7174,7173,7172,7171,10407,7170,7169,7168,7167,7166,7165,7164,7163,7162,7161,7160,7159,7158,7157,7155},
        {7495,7518,7568,7517,7516,7515,7514,7513,7512,7511,7510,7509,7508,7507,7506,7505,7504,7503,7502,7501,7500,7499,7498,7496,7497},
        {7629,7666,7665,7664,7663,10410,7662,7661,7660,7659,7658,7657,7656,7655,7654,7653,7652,7651,7650,7649,7648,7647,7646,7645,7644,7643,7642,10409,7641,7640,7639,7638,7637,7636,7635,7634,7633,10408,7632,7631,7630},
        {8540,8541,8544,8545,8546,8547,8548,8549,8552,8553,8554,8555,8556,8557,8558,8559,8560,8561,8562,8563,8564,8565,8566,8567,8568,8569,8570,8571,8572,8573,8574,8575,10418,10419},
        {8653,8650,8651,8652,8654,8655,8656,8663,8664,8667,8668,8669,8670,8671,8675,8676,8677,8678,8679,8680,8687,8690,8691,8692,8693,8694,8695,8696,8697,8698,8699,8700,8701,8702,10420,10421},
        {8814,8815,8816,8817,8818,8819,8820,8821,8822,8823,8824,8825,8826,8827,8828,8829,8830,8831,8832,8833,8834,8835,8836,8837,8838,8839,8840,8841,8842,8856,8813,10422,10424},
        {8914,8945,8917,8918,8919,8920,8921,8922,8923,8924,8925,8926,8927,8928,8929,8930,8931,8932,8933,8934,8935,8936,8937,8938,8939,8940,8941,8942,8943,8944,8913,10425,10426},
        {9036,9037,9038,9039,9040,9041,9042,9043,9044,9045,9046,9047,9048,9049,9050,9051,9052,9053,9054,9055,9056,9057,9058,9059,9060,10427,9066,9070},
        {9143,9144,9147,9148,9149,9150,9151,9154,9155,9156,9160,9161,9162,9164,9165,9166,9167,9170,9171,9172,9173,9174,9177,9178,9179,9180,9181,9184,9185,9187,9188,9191,9192,9193,10428,9153},
        {9567,9569,9575,9574,9576,9578,9577,9572,9591,9573,9579,9587,9589,9586,9582,9663,9664,9665,9666,9667,9668,9669,9660,9670,9671,9672,9673,9674,9675,9645,9724,10429,10430}
     }
function obj_replay_case:state(state,guestID)
    if (state == "pre_check") then
        obj_replay_case:pre_check()
    else
        local state_ = tonumber(state)
        if (state_ == nil) then
            return
        end
        obj_replay_case:case(state_)
    end
end
function obj_replay_case:case(case_num)
    local select_case = viewer.getOptParamI("cases.select",0,1)
    local tasks = case_tasks[select_case]
    for i=1,#tasks do
        local task = tasks[i]
        viewer.setObjParamI (145, "param", task)
        viewer.changeObjState (145, "reactivate")
    end   
    viewer.setOptParamS("param","mg_arrest.cases",0)
    viewer.changeObjState (46, "delete_node")
end
function obj_replay_case:pre_check()
    local max_num_case = viewer.getOptParamI("cases.max_num_case",0,1)
    local num_case = viewer.getOptParamI("num_case",0,1)
    local win_deal = viewer.getOptParamI("finish_case.win_deal"..num_case,0,1)
    if (max_num_case == 15) then --при добавлении нового кейса этот параметр делать +1
        if (num_case < 16) then --при добавлении нового кейса этот параметр делать +1
            if (win_deal == 1) then
                viewer.setOptParamI("num_case",15,1) --при добавлении нового кейса этот параметр делать +1
            end
        end
    end   
end

obj_root_cases_rank = class()
function obj_root_cases_rank:init()
    self.ranks_resID = {11486, 13410, 13412, 13411 }
    self.shields_replay = {37556,37560,37566,37572,37578,37584,37590,37596,37602,37608,48359,48690,48862,49112,49419}
end
function obj_root_cases_rank:state(state,guestID)
  	function finish_case()
        local case = viewer.getOptParamI("num_case",100,1)
        local gold_case = viewer.getOptParamI("dog.gold_case",0,1)  
        local rank = viewer.getOptParamI("cases.case"..case..".rank",0,1)        
        local max_num_case = viewer.getOptParamI("cases.max_num_case",0,1)
        if (case == 1 or gold_case == 1) then
            rank = 3
        elseif (case == 3 and (viewer.getOptParamI("dog.end_tut", 0, 1) == 0)) then --после 3 кейса даем золотую медаль, чтобы получить пса
            rank = 3
        elseif (case > 3 and (viewer.getOptParamI("dog.show_dog_map", 0, 1) == 0)) then -- если текущий кейс больше третьего и собаки еще нет на карте, то даем золотую медаль
            rank = 3
        elseif (case > 900) then --за ивенты мы всегда получаем только золото
            rank = 3
        else
            local P = 70
            if (rank == 1) then
                local rnd = math.random(100)
                if (rnd > P) then
                    rank = 3
                else 
                    rank = rank + 1
                end
            else 
                rank = rank + 1    
            end
            if (rank > 3) then
                rank = 3
            end 
        end
        if(case > max_num_case and case < 900) then
            viewer.setOptParamI("cases.max_num_case", case, 1)
        end
        viewer.setOptParamI("cases.case"..case..".rank",rank,1)
        max_num_case = viewer.getOptParamI("cases.max_num_case",0,1)
        if (rank == 3 and max_num_case > 2) then
            viewer.setObjParamI(22,"param",10500)
            viewer.changeObjState(22,"add_param")
        end
        viewer.changeObjState(39156,"scale")
    end
    function actualize()
        local case = viewer.getOptParamI("num_case",100,1)
        local rank = viewer.getOptParamI("cases.case"..case..".rank",0,1)
        if (guestID == 24776) then
            if (viewer.getObjParamS(guestID,"curSt","init") == "on"
                    and viewer.getOptParamI("cases.finish_case",0,1) == 1) then
                viewer.changeObjState(24313,"draw"..rank)
                viewer.changeObjState(24313,"anim")
            else
                viewer.changeObjState(24313,"draw"..rank)
            end
        end
        if (guestID == 39156) then
            viewer.changeObjState(39157,"draw"..rank)
        end
        if (guestID == 37524) then
            for i = 2, #self.shields_replay do
                local rank = viewer.getOptParamI("cases.case"..i..".rank",0,1)
                viewer.setObjParamI(self.shields_replay[i],"res",self.ranks_resID[rank+1])
                viewer.changeObjState(self.shields_replay[i],"init")
            end
        end
    end
	if 	(state == "finish_case") then
        finish_case()
    end
    if 	(state == "actualize") then
        actualize()
    end
end

obj_root_safe = class()
function obj_root_safe:fill_true_code()
    local Num1=0
    local Num2=0
    local Num3=0
    local Num4=0
    local trueCode=0
    local trueCodeArray={}
    local trueCodeArrayHint={}
    Num1=viewer.getObjParamS(28296,"codeNum1",2)
    Num2=viewer.getObjParamS(28296,"codeNum2",2)
    Num3=viewer.getObjParamS(28296,"codeNum3",3)
    Num4=viewer.getObjParamS(28296,"codeNum4",5)
    for i=1,4 do
        trueCodeArray[i]=viewer.getObjParamS(28296,"codeNum"..i,2)
        trueCodeArrayHint[i]=viewer.getObjParamS(28296,"codeNum"..i,2)
    end
    trueCode=Num1..Num2..Num3..Num4
    return trueCode, trueCodeArray, trueCodeArrayHint
end
function swap(trueCodeArrayHint, index1, index2)
    trueCodeArrayHint[index1], trueCodeArrayHint[index2] = trueCodeArrayHint[index2], trueCodeArrayHint[index1]
end
function shuffle(array)
    local counter = #array
    while counter > 1 do
        local index = math.random(counter)
        swap(array, index, counter)
        counter = counter - 1
    end
end
function obj_root_safe:fill_icons()
    for i=1,30 do
        local resParam=tonumber(viewer.getObjParamS(28296,"param_res"..i,nil))
        obj_root_safe.iconsSafeArray[i]=resParam
        viewer.setObjParamS(obj_root_safe.hintIconArray[i],"res",obj_root_safe.iconsSafeArray[i])
        viewer.changeObjState(obj_root_safe.hintIconArray[i],"init")
    end
    for i,v in ipairs(obj_root_safe.iconsSafeArray) do print(obj_root_safe.iconsSafeArray[i]) end
end
function obj_root_safe:compare_array()
    local numArray = 0
    local compArray={}
    for i = 1, 5 do
        numArray = 0
        for j = 1, 5 do
            if (obj_root_safe.txtArray[i]==obj_root_safe.txtArray[j]) then
            numArray=numArray+1
            end
            compArray[i]=numArray
        end
    end
    for n=1,5 do
        obj_root_safe.compareValid=n
        if (compArray[n]>1 or compArray[n]==obj_root_safe.trueCodeNum) then
            obj_root_safe.fill_hint()
            break
        end
    end
end
function obj_root_safe:fill_hint()
    shuffle(obj_root_safe.trueCodeArrayHint)
    obj_root_safe.txtArray[obj_root_safe.compareValid]=obj_root_safe.trueCodeArrayHint[1]..obj_root_safe.trueCodeArrayHint[2]..obj_root_safe.trueCodeArrayHint[3]..obj_root_safe.trueCodeArrayHint[4]
    obj_root_safe.compare_array()
    print("fill_hint")
end
function obj_root_safe:start()
    self.trueCodeNum="0" --правильный код в данной игре
    self.enteredCodeNum="0" --введенный игроком код
    self.buttonNum=0  --кнопка, на которую нажал игрок последней
    self.enteredCode="0"  --введенный игроком код, который отображается на экране
    self.hint=0 --номер хинта
    self.trueCodeArray={} --массив для правильного кода
    self.trueCodeArrayHint={} --массив,который используется для shuffle в хинте
    self.hintIconArray={28323,51066,51067,28328,51064,51065,28333,51062,51063,28338,51060,51061,28343,51058,51059,28348,51056,51057,28353,51054,51055,28358,51052,51053,28363,51050,51051,28368,51048,51049} --иконки-подсветки
    self.iconsSafeArray={}  --массив графики для иконок
    self.shineHintIcon={28324,28329,28334,28339,28344,28349,28354,28359,28364,28369}  --массив машинок-подсветок
    self.icoHint={28325,28330,28335,28340,28345,28350,28355,28360,28365,28370} --иконки на кнопках
    self.txtArray={} -- массив для хинта с возможными значениями.
    self.compareValid=0
end
function obj_root_safe:state(state,guestID)
    if 	(state == "start") then
        self.trueCodeNum, self.trueCodeArray, self.trueCodeArrayHint = obj_root_safe.fill_true_code()
        obj_root_safe.fill_icons()
        viewer.setObjParamS(28376,"txt","-------")
        viewer.changeObjState(28376,"init")
        viewer.setObjParamS(51177,"txt","")
        viewer.changeObjState(51177,"init")
        viewer.setObjParamS(28382,"codeParam1","-")
        viewer.setObjParamS(28382,"codeParam2","-")
        viewer.setObjParamS(28382,"codeParam3","-")
        viewer.setObjParamS(28382,"codeParam4","-")
        for i = 1, 30 do
            viewer.setObjParamS(28296,"param_res"..i,"")--очищаем всю графику кнопок для следующего кейса
        end
        print("trueCodeNum ",self.trueCodeNum)
    end
	if 	(state == "check") then
        local codeNum=viewer.getObjParamS(28382,"codeParam",99)
        self.buttonNum=self.buttonNum+1
        print("enteredCode ",self.buttonNum..codeNum)
        viewer.setObjParamS(28382,"codeParam"..self.buttonNum,codeNum)
        local Num1=viewer.getObjParamS(28382,"codeParam1","-")
        local Num2=viewer.getObjParamS(28382,"codeParam2","-")
        local Num3=viewer.getObjParamS(28382,"codeParam3","-")
        local Num4=viewer.getObjParamS(28382,"codeParam4","-")
        self.enteredCode=Num1.."-"..Num2.."-"..Num3.."-"..Num4
        self.enteredCodeNum=Num1..Num2..Num3..Num4
        viewer.setObjParamS(28376,"txt",self.enteredCode)
        viewer.changeObjState(28376,"init")
        print("enteredCode ",self.enteredCode)
        if (self.buttonNum>4) then
            viewer.changeObjState(28299,"end")
        end
        if (self.buttonNum==4) then
            viewer.changeObjState(28372,"help")
            viewer.changeObjState(28371,"to_tap")
        end    
    end
    if 	(state == "enter") then
        viewer.changeObjState(28372,"init")
        if (self.trueCodeNum==self.enteredCodeNum and self.buttonNum>=4) then 
            self.buttonNum=0
            viewer.setObjParamS(28297,"txt","win")
            viewer.changeObjState(28297,"init")
            viewer.changeObjState(28382,"reset")
            viewer.changeObjState(28382,"win")
            print("win")
        elseif (self.trueCodeNum~=self.enteredCodeNum and self.buttonNum>=4) then
            local failNum=0
            failNum=failNum+1
            if (failNum==2) then
                viewer.changeObjState(28393,"help")
                failNum=0
            end
            local resultCode = "" --показывает,какие цифры на своих местах
            local resultCodeX = "" --показывает,на каких местах цифры неправильные
            local Num1=viewer.getObjParamS(28382,"codeParam1","-")
            local Num2=viewer.getObjParamS(28382,"codeParam2","-")
            local Num3=viewer.getObjParamS(28382,"codeParam3","-")
            local Num4=viewer.getObjParamS(28382,"codeParam4","-")
            local enteredArr={Num1,Num2,Num3,Num4}--массив с введенными цифрами
            for i=1,4 do 
                if (self.trueCodeArray[i]==enteredArr[i]) then
                    if (i==1) then
                        resultCode = resultCode..self.trueCodeArray[i]
                        resultCodeX = resultCodeX.."__"
                    else
                        resultCode = resultCode.."-"..self.trueCodeArray[i]
                        resultCodeX = resultCodeX.."___"
                    end
                elseif (self.trueCodeArray[i]~=self.enteredCodeNum[i]) then
                    if (i==1) then
                        resultCode = resultCode.."__"
                        resultCodeX = resultCodeX.."x"
                    else
                        resultCode = resultCode.."-__"
                        resultCodeX = resultCodeX.."_x"
                    end 
                end
            end
            viewer.setObjParamS(28376,"txt",resultCode)
            viewer.changeObjState(28376,"init") 
            viewer.setObjParamS(51177,"txt",resultCodeX)
            viewer.changeObjState(51177,"init")
            viewer.changeObjState(28382,"fail")
            self.buttonNum=0
            viewer.setObjParamS(28297,"txt","fail")
            viewer.changeObjState(28297,"init")
            viewer.changeObjState(28299,"init")
            print("fail")
        end
    end
    if 	(state == "reset_for_buttons") then 
        local Param4=viewer.getObjParamS(28382,"codeParam4")
        local redText=viewer.getObjParamS(51177,"txt")
        if (Param4=="-")then
            if(redText=="")then
                redText=""
            else
                viewer.changeObjState(28382,"reset")
            end  
        else
            if(redText=="")then
                redText=""
            else
                viewer.changeObjState(28372,"init")
                viewer.changeObjState(28371,"init")
                viewer.setObjParamS(28382,"codeParam1","-")
                viewer.setObjParamS(28382,"codeParam2","-")
                viewer.setObjParamS(28382,"codeParam3","-")
                viewer.setObjParamS(28382,"codeParam4","-")
                viewer.setObjParamS(28376,"txt","-------")
                viewer.changeObjState(28376,"init")
                viewer.setObjParamS(51177,"txt","")
                viewer.changeObjState(51177,"init")
                self.buttonNum=0
            end
        end   
    end  
    if 	(state == "reset") then 
        viewer.changeObjState(28372,"init")
        viewer.changeObjState(28371,"init")
        viewer.setObjParamS(28382,"codeParam1","-")
        viewer.setObjParamS(28382,"codeParam2","-")
        viewer.setObjParamS(28382,"codeParam3","-")
        viewer.setObjParamS(28382,"codeParam4","-")
        viewer.setObjParamS(28376,"txt","-------")
        viewer.changeObjState(28376,"init")
        viewer.setObjParamS(51177,"txt","")
        viewer.changeObjState(51177,"init")
        viewer.changeObjState(28299,"init")
        self.buttonNum=0
    end
    if 	(state == "hint") then
        self.hint=self.hint+1
        if(self.hint==3)then
            local hintTxt=""
            for i=1,4 do
                local NumArray1=0
                local NumArray2=0
                local NumArray3=0
                local NumArray4=0
                shuffle(self.trueCodeArrayHint)
                self.txtArray[i]=self.trueCodeArrayHint[1]..self.trueCodeArrayHint[2]..self.trueCodeArrayHint[3]..self.trueCodeArrayHint[4]
            end
            obj_root_safe.compare_array() -- Поиск одинаковых значений в массиве и их замена
            self.txtArray[5]=self.trueCodeNum -- Добавляем правильный вариант
            shuffle(self.txtArray)
            hintTxt=self.txtArray[5]..","..self.txtArray[2]..","..self.txtArray[3]..","..self.txtArray[4]..","..self.txtArray[1]
            viewer.setObjParamS(28436,"txt",hintTxt)
            viewer.changeObjState(28436,"init")
            viewer.changeObjState(28383,"hint_3")
        elseif (self.hint==1) then
            for i=1,4 do
                for i,v in ipairs(self.shineHintIcon) do 
                    print(self.shineHintIcon[i]) 
                end
                local resNum=self.trueCodeArrayHint[i]
                if (tonumber(resNum)==0)then
                    resNum=10
                end
                local iconID=self.icoHint[tonumber(resNum)]
                local shineID=self.shineHintIcon[tonumber(resNum)]
                local resID=viewer.getObjParamS(28296,"trueRes",-1)
                viewer.setObjParamS(iconID,"res",14519) --resID 14519
                viewer.changeObjState(iconID,"init")
                viewer.changeObjState(shineID,"shine")
                viewer.changeObjState(28383,"hint_1")
                print ("resNum ",tostring(resNum))
                print ("iconID ",tostring(iconID))
            end
        elseif (self.hint>=3) then
            viewer.changeObjState(28383,"hint_3")
            viewer.setObjParamS(28436,"txt",self.trueCodeNum)
            viewer.changeObjState(28436,"init")
        else
            viewer.changeObjState(28383,"hint_"..self.hint)
        end
    end
end

obj_root_shuffle = class()
function obj_root_shuffle:fill_array(guest)
    local num_case = viewer.getOptParamI("num_case",1,1)
    if num_case > 900 then 
        num_case = viewer.getOptParamI("num_case_event",1,1) + 20
        print("num case = "..num_case)
    end
    local shift = 0 
    if (viewer.getOptParamI("tasks145.t9162.s",0,1) == 2) then
        shift = 0
    end
    if (viewer.getOptParamI("tasks145.t9185.s",0,1) == 2) then
        shift = 3
    end
    local arrayShuffle = {} -- массив графических id ресурсов массовки
    for i = 1, #conveyorSettings[num_case][1+shift] do
        arrayShuffle[i] = conveyorSettings[num_case][1+shift][i]
    end
    local corps = {} -- массив графических id ресурсов правильных предметов
    local siluet = {} -- массив силуетов
    local aMachines={} -- массив id движущихся объектов
    local aTrueRes = conveyorSettings[num_case][3+shift]  -- массив графических id ресурсов, которые покажутся после выигрыша
    for i = 1, #conveyorSettings[num_case][2+shift] do
        corps[i] = conveyorSettings[num_case][2+shift][i][1]
        siluet[i] = conveyorSettings[num_case][2+shift][i][2]
    end
    local pairs = conveyorSettings[num_case][2+shift]
    for i=1,#arrayShuffle do
        aMachines[i]=self.arrayAllMachines[i]
    end
    return arrayShuffle, corps, aMachines, aTrueRes , siluet, pairs
end
function swap(corpsFind, index1, index2)
    corpsFind[index1], corpsFind[index2] = corpsFind[index2], corpsFind[index1]
end
function shuffle(array)
    local counter = #array
    while counter > 1 do
        local index = math.random(counter)
        swap(array, index, counter)
        counter = counter - 1
    end
end
function obj_root_shuffle:init()
    self.tutorial=viewer.getOptParamI("conveyor.tut",0,1) -- Параметр туториала
    self.arrayLength=0                                    -- Длина массива с графикой
    self.machineRun=0                                     -- Номер запускаемой машины
    self.cicleRun=0                                       -- Начало/конец цикла
    self.nextArrow=0                                      -- Подсветка туториала                   
    self.time=0                                           -- Время до запуска последующей машины    
    self.hint=0                                           -- Параметр запуска хинта  
    self.hint_time=0                                      -- Время действия хинта
    self.itemsNeeded=0                                    -- Кол-во необходимых предметов
    self.itemsFind=0                                      -- Кол-во найденных предметов
    self.rand_time=850                                    -- начальное время между генерацией предметов на ленте
    self.cicle_time=7000                                  -- начальное время полного цикла (вроде как уже не нужно)
    self.gamespeed = 0
    self.arrayAllMachines=
        {
            29702,29705,29708,29711,29714,
            29717,29720,29723,29726,29729,
            29732,29735,29738,29741,29744
         }
end
function obj_root_shuffle:timer(dt)                     -- Движение машин в таймере
    self.time=self.time+dt
    local randTime=0
    local startGame=tonumber(viewer.getObjParamS(29748,"start_game",0))
    local gameSpeed=tonumber(viewer.getObjParamS(29675,"speedParam",0))
    local cicleTime=0
    if (gameSpeed < self.gamespeed)then
        self.time = self.time - 10
    end
    if (self.cicleRun==1) then
        if (self.time>=self.cicle_time) then
            self.cicleRun=0
        end
    else
        if (self.time>=self.rand_time and startGame==1) then 
            if (tonumber(self.tutorial) == 1) then                      -- Рандомим время для симмуляции жизни
                if (gameSpeed == 2) then                                -- Высокая скорость движения предметов
                    cicleTime=4000
                    randTime=400
                elseif (gameSpeed == 1) then                            -- Средняя скорость движения предметов
                    cicleTime=5500
                    randTime=550 
                else                                                    -- Низкая скорость движения предметов
                    cicleTime=8500
                    randTime=850
                end
            else                            -- туториал не окончен (этот кусок больше вроде как не используется)                            
                if (gameSpeed == 0) then                                -- Низкая скорость движения предметов
                    cicleTime=8500
                    randTime=850 
                elseif (gameSpeed == -1) then                           -- Очень низкая скорость движения предметов
                    cicleTime=8500
                    randTime=850
                end
            end
            self.rand_time = randTime
            self.cicle_time = cicleTime
            self.gamespeed = gameSpeed
            self.cicle_time = math.floor(self.cicle_time*((self.arrayLength+1 - self.itemsFind)/self.arrayLength))
            self.time = 0 -- важно обнулить этот параметр чтобы можно было его снова накапливать
            self.machineRun = self.machineRun + 1 -- номер по счету сгенерированной машины
            while (tonumber(self.arrayMachines[self.machineRun]) == -1) do
                self.machineRun = self.machineRun + 1
            end
            if (tonumber(self.tutorial) == 1) then                -- Туториальные машины
                if (self.hint == 1) then                            -- Условие запуска хинта
                    local need_find_siluet = obj_root_shuffle.Siluets[1]
                    local need_find
                    for i = 1, #obj_root_shuffle.Pairs do
                        if (obj_root_shuffle.Pairs[i][2] == need_find_siluet) then
                            need_find = obj_root_shuffle.Pairs[i][1]
                            break
                        end
                    end
                    if (tonumber(viewer.getObjParamI(self.arrayMachines[self.machineRun],"setType",0))==1 and
                        viewer.getObjParamI(self.arrayMachines[self.machineRun]+1,"res",0) == need_find) then
                        viewer.setObjParamS(self.arrayMachines[self.machineRun],"al",1)
                        viewer.changeObjState(self.arrayMachines[self.machineRun],"hint")
                        self.hint=0
                    else
                        viewer.changeObjState(self.arrayMachines[self.machineRun],"move")
                    end
                else
                    viewer.changeObjState(self.arrayMachines[self.machineRun],"move")
                end
            else
                local need_find_siluet = obj_root_shuffle.Siluets[1]
                local need_find
                    for i = 1, #obj_root_shuffle.Pairs do
                        if (obj_root_shuffle.Pairs[i][2] == need_find_siluet) then
                            need_find = obj_root_shuffle.Pairs[i][1]
                            break
                        end
                    end
                    if (tonumber(viewer.getObjParamI(self.arrayMachines[self.machineRun],"setType",0))==1 
                    and viewer.getObjParamI(self.arrayMachines[self.machineRun]+1,"res",0) == need_find) then
                        viewer.changeObjState(self.arrayMachines[self.machineRun],"move")
                        if (self.nextArrow~=1) then
                            viewer.changeObjState(self.arrayMachines[self.machineRun],"move_win_tutorial")
                            viewer.changeObjState(29749,"hint")
                            viewer.changeObjState(29856,"open1")
                            self.nextArrow=1
                        end
                    else
                        viewer.changeObjState(self.arrayMachines[self.machineRun],"move")
                    end
                end
            if (self.machineRun>=self.arrayLength) then
                self.machineRun=0
                self.nextArrow=0
            end
        end 
        if (self.time>=self.rand_time+300 and startGame==2) then
            for i=1,self.arrayLength do
                local curStMachine=viewer.getObjParamS(self.arrayMachines[i],"curSt","move")
                if (curStMachine=="move" or curStMachine=="hint" or curStMachine=="move_tutorial"
                or curStMachine=="move_win_tutorial" or curStMachine=="rgb_w"
                or curStMachine=="rgb_w_tutorial" or curStMachine=="rgb_f") then
                    viewer.changeObjState(self.arrayMachines[i],"move_out")
                end
            end
            local lastTrueObj=viewer.getObjParamI(29748,"paramCheck",-1)
            viewer.changeObjState(lastTrueObj,"move_out")
            viewer.setObjParamI(29748,"paramCheck",-1)
        end
    end 
end
function obj_root_shuffle:state(state,guestID)
	if 	(state == "fill_array") then
        local arrayIcons={29703,29706,29709,29712,29715,29718,29721,29724,29727,29730,29733,29736,29739,29742,29745}
        self.RootResources, self.CorpsResources, self.arrayMachines, self.aTrueRes, self.Siluets, self.Pairs = obj_root_shuffle:fill_array(guestID)
        self.arrayLength=#self.RootResources
        shuffle(self.RootResources)
        for i=1,#self.RootResources do
            if (self.RootResources[i]==-1) then
                self.itemsNeeded=self.itemsNeeded+1
                math.randomseed(os.time())
                randomCorp=math.random(#self.CorpsResources)
                local corpsNum=self.CorpsResources[randomCorp]
                table.remove(self.CorpsResources,randomCorp)
                self.RootResources[i]=corpsNum
                viewer.setObjParamS(29747,"setType"..i,1)
                viewer.setObjParamI(self.arrayMachines[i],"setType",1)
            else
                viewer.setObjParamS(29747,"setType"..i,0)
                viewer.setObjParamI(self.arrayMachines[i],"setType",0)
            end
            local resIm=self.RootResources[i]
            viewer.setObjParamS(arrayIcons[i],"res",resIm)
            viewer.changeObjState(arrayIcons[i],"init")
        end
        viewer.setObjParamS(29685,"val",self.itemsNeeded)
        viewer.changeObjState(29685,"init")
        viewer.changeObjState(29683,"min")
        viewer.changeObjState(29683,"init")
        viewer.changeObjState(29675,"win")
	end
end

obj_ss_timers = class()
function obj_ss_timers:state(state, guestID)
    if (state == "set_timer") then
        local IdTimer = viewer.getObjParamI(45945, "timer_id", 0) 
        local IdScenario = viewer.getObjParamS(guestID, "sales_scenario", "none")
        if (IdTimer == 0) then
            print("Timer id isn't set!")
        elseif (IdScenario == "none") then
            print("Object which called set_timer_of_sales didn't have parametr sales_scenario")
        else  
            local pathToTime = "salesmanager44333.ev"..IdScenario..".tl"
            local actualTime = viewer.getOptParamI(pathToTime, 0, 1) * 1000
            viewer.setObjParamS(IdTimer, "val", actualTime)
            viewer.changeObjState(IdTimer, "init")
            viewer.changeObjState(IdTimer, "run")
        end
    end
end  

